import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, EventEmitter, Input, Output, NgModule, TemplateRef, ViewContainerRef, Directive, Renderer2, ElementRef, HostListener } from '@angular/core';
import { CommonModule } from '@angular/common';
import { isNullOrUndefined, Toolkit2, UtilModule, ActionMode, CommonDevTools, PageContainer, Paging } from '@angular-boot/util';
import { FormsModule } from '@angular/forms';
import swal from 'sweetalert2';

class ShrPaginationEvent {
    constructor(page, size) {
        this.page = page;
        this.size = size;
    }
}

let CommonService = class CommonService {
    constructor() { }
};
CommonService.ngInjectableDef = ɵɵdefineInjectable({ factory: function CommonService_Factory() { return new CommonService(); }, token: CommonService, providedIn: "root" });
CommonService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], CommonService);

let CommonComponent = class CommonComponent {
    constructor() { }
    ngOnInit() {
    }
};
CommonComponent = __decorate([
    Component({
        selector: 'lib-common',
        template: `
    <p>
      common works!
    </p>
  `
    })
], CommonComponent);

let PaginationComponent = class PaginationComponent {
    // @Output() indicatorCountChange: EventEmitter<number> = new EventEmitter<number>();
    constructor() {
        this.size = 5;
        this.showTotalPage = true;
        this.showSizeSelection = true;
        this.sizeSelectionArray = [5, 10, 20, 50];
        this.defaultSizeIndex = 0;
        // private _currentPage: number;
        // @Input()
        // set currentPage(val) {
        //   console.log('set currentPage');
        //   this._currentPage = val;
        //   this.initiateCurrentIndicator(this._currentPage);
        // }
        //
        // get currentPage(): number {
        //   return this._currentPage;
        // }
        this.indicates = [];
        this.pageSizeChange = new EventEmitter();
        /**
         * @Deprecated use currentPageChange instead
         */
        this.selectedPage = new EventEmitter();
        this.currentPageChange = new EventEmitter();
        this.sizeChange = new EventEmitter();
    }
    ngOnInit() {
        this.indicatorCount = this.indicatorCount || 5;
        this.calculateOffset();
        // this.initiateCurrentIndicator(this._currentPage);
        this.initiateCurrentIndicator(this.currentPage);
        this.generateIndicates();
    }
    generateIndicates() {
        this.indicates = [];
        for (let i = this.offset; i < this.offset + this.indicatorCount; i++) {
            if (i <= this.totalPages) {
                this.indicates.push(i);
            }
        }
    }
    initiateCurrentIndicator(i) {
        this.currentIndicator = +(i || 0) + 1;
    }
    setCurrentIndicator(i) {
        this.currentIndicator = i;
        this.emitSelectedPage(this.currentIndicator - 1);
    }
    nextimize() {
        if (this.offset + this.indicatorCount <= this.totalPages) {
            this.offset = this.offset + this.indicatorCount;
            this.setCurrentIndicator(this.offset);
        }
        else {
            if (this.currentIndicator < this.totalPages) {
                this.setCurrentIndicator(this.currentIndicator + 1);
            }
        }
        this.generateIndicates();
    }
    previmize() {
        if (this.offset - this.indicatorCount >= 1) {
            this.offset = this.offset - this.indicatorCount;
            this.setCurrentIndicator(this.offset + this.indicatorCount - 1);
        }
        else {
            if (this.currentIndicator > 1) {
                this.setCurrentIndicator(this.currentIndicator - 1);
            }
        }
        this.generateIndicates();
    }
    reFirst() {
        this.offset = 1;
        this.setCurrentIndicator(1);
        this.generateIndicates();
    }
    reLast() {
        this.setCurrentIndicator(this.totalPages);
        const co = Math.trunc(this.totalPages / this.indicatorCount);
        if (co * this.indicatorCount === this.totalPages) {
            this.offset = this.totalPages - this.indicatorCount + 1;
        }
        else {
            this.offset = (co * this.indicatorCount) + 1;
        }
        this.generateIndicates();
    }
    childNgOnChanges(changes) {
        for (const propName in changes) {
            if (changes.hasOwnProperty(propName)) {
                this.onChange(propName, changes);
            }
        }
    }
    ngOnChanges(changes) {
        this.childNgOnChanges(changes);
    }
    onChange(propName, changes) {
        switch (propName) {
            case 'currentPage':
                // console.log('set currentPage');
                this.initiateCurrentIndicator(this.currentPage);
                this.generateIndicates();
                break;
            case 'totalPages':
                if (!isNullOrUndefined(this.totalPages)) {
                    this.generateIndicates();
                }
                break;
            case 'defaultSizeIndex':
                if (!isNullOrUndefined(this.defaultSizeIndex)) {
                    if (this.defaultSizeIndex < 0) {
                        this.defaultSizeIndex = 0;
                        throw new Error('defaultSizeIndex should not be less than 0');
                    }
                    else if (this.defaultSizeIndex >= this.sizeSelectionArray.length) {
                        this.defaultSizeIndex = this.sizeSelectionArray.length - 1;
                        throw new Error('defaultSizeIndex should not be less than 0');
                    }
                    this.size = this.sizeSelectionArray[this.defaultSizeIndex];
                }
                break;
        }
    }
    en2Fa(value) {
        return Toolkit2.Common.En2Fa(value);
    }
    emitSelectedPage(page) {
        this.currentPage = page;
        this.currentPageChange.emit(page);
        this.selectedPage.emit(page);
        this.pageSizeChange.emit(new ShrPaginationEvent(page, this.size));
    }
    onSizeChange(event) {
        console.log(event);
        this.sizeChange.emit(event);
        // console.log('prev size: ', this.size);
        // console.log('current size: ', event);
        if (event > this.size) { // if current_size is larger than prev_size
            this.currentPage = Math.floor(this.currentPage / Math.ceil(event / this.size));
        }
        this.calculateOffset();
        this.pageSizeChange.emit(new ShrPaginationEvent(this.currentPage, event));
    }
    calculateOffset() {
        this.offset = Math.floor(this.currentPage / this.indicatorCount) * this.indicatorCount + 1;
    }
};
__decorate([
    Input()
], PaginationComponent.prototype, "size", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "offset", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "indicatorCount", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "showTotalPage", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "showSizeSelection", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "sizeSelectionArray", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "defaultSizeIndex", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "totalPages", void 0);
__decorate([
    Input()
], PaginationComponent.prototype, "currentPage", void 0);
__decorate([
    Output()
], PaginationComponent.prototype, "pageSizeChange", void 0);
__decorate([
    Output()
], PaginationComponent.prototype, "selectedPage", void 0);
__decorate([
    Output()
], PaginationComponent.prototype, "currentPageChange", void 0);
__decorate([
    Output()
], PaginationComponent.prototype, "sizeChange", void 0);
PaginationComponent = __decorate([
    Component({
        selector: 'shr-pagination',
        template: "<!--Pagination 1-->\n<nav class=\"Pager1\" aria-label=\"pagination example\">\n  <div class=\"d-flex justify-content-between align-items-center\">\n    <div class=\"\">\n      <span *ngIf=\"showTotalPage\">\u0635\u0641\u062D\u0647 {{+currentPage + 1 | nbpipe: en2Fa}} \u0627\u0632 {{totalPages | nbpipe: en2Fa}}</span>\n    </div>\n    <div class=\"\">\n      <ul class=\"pagination pagination-circle justify-content-center\">\n\n        <!--First-->\n        <li class=\"page-item\"\n            [ngClass]=\"{disabled: currentIndicator === 1, 'cursor-pointer': currentIndicator !== 1}\">\n          <a class=\"page-link\" (click)=\"reFirst()\">\u0627\u0648\u0644\u06CC\u0646</a>\n        </li>\n\n        <!--Arrow left-->\n        <li class=\"page-item\" [ngClass]=\"{disabled: currentIndicator === 1, 'cursor-pointer': currentIndicator !== 1}\">\n          <a class=\"page-link\" aria-label=\"Previous\" (click)=\"previmize()\">\n            <span aria-hidden=\"true\">&laquo;</span>\n            <span class=\"sr-only\">Previous</span>\n          </a>\n        </li>\n\n        <!--Numbers-->\n        <ng-container *ngFor=\"let i of indicates\">\n          <li class=\"page-item\" [ngClass]=\"{'active': i === currentIndicator}\" style=\"cursor: pointer;\">\n            <a class=\"page-link\" (click)=\"setCurrentIndicator(i)\">{{i}}</a>\n          </li>\n        </ng-container>\n        <!--Arrow right-->\n        <li class=\"page-item\" [ngClass]=\"{disabled: currentIndicator === totalPages, 'cursor-pointer': currentIndicator !== totalPages}\">\n          <a class=\"page-link\" aria-label=\"Next\" (click)=\"nextimize()\">\n            <span aria-hidden=\"true\">&raquo;</span>\n            <span class=\"sr-only\">Next</span>\n          </a>\n        </li>\n\n        <!--Last-->\n        <li class=\"page-item\"\n            [ngClass]=\"{disabled: currentIndicator === totalPages, 'cursor-pointer': currentIndicator !== totalPages}\">\n          <a class=\"page-link\" (click)=\"reLast()\">\u0622\u062E\u0631\u06CC\u0646</a>\n        </li>\n      </ul>\n    </div>\n    <div class=\"col-2\">\n      <ng-container *ngIf=\"showSizeSelection\">\n        <!--        <ng-select id=\"size\" name=\"size\" [(ngModel)]=\"size\" (change)=\"onSizeChange($event)\">-->\n        <!--          <ng-option *ngFor=\"let item of sizeSelectionArray\" [value]=\"item\"> {{item}}</ng-option>-->\n        <!--        </ng-select>-->\n        <select id=\"size\" name=\"size\" class=\"form-control\" (ngModelChange)=\"onSizeChange($event)\" [(ngModel)]=\"size\">\n          <option *ngFor=\"let item of sizeSelectionArray\" [value]=\"item\"> {{item}}</option>\n        </select>\n      </ng-container>\n    </div>\n  </div>\n</nav>\n",
        styles: ["nav{margin:10px auto 0}.pagination.pagination-circle .page-item.active .page-link{border-radius:50%}.pagination .page-item .page-link:hover{transition:.3s linear;border-radius:.125rem;background-color:#ccc}.pagination{margin-top:15px}.pagination.pg-blue .page-item.active .page-link:hover{background-color:#bd5410}.pagination .page-item.active .page-link{transition:.2s linear;border-radius:.125rem;background-color:#bd5410;color:#fff;box-shadow:0 2px 5px 0 rgba(0,0,0,.16),0 2px 10px 0 rgba(0,0,0,.12)}.pagination .page-item .page-link{border-radius:.125rem;transition:.3s linear;outline:0;border:0;background-color:transparent;font-size:.9rem;color:#999;font-weight:700}.pagination.pagination-circle .page-item .page-link:hover{border-radius:50%}.pagination.pagination-circle .page-item .page-link{margin-left:2px;margin-right:2px;border-radius:50%}.page-link{border:none!important}"]
    })
], PaginationComponent);

let ShrPaginationModule = class ShrPaginationModule {
};
ShrPaginationModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            UtilModule,
            FormsModule
        ],
        declarations: [PaginationComponent],
        exports: [
            PaginationComponent
        ]
    })
], ShrPaginationModule);

let SortingIconComponent = class SortingIconComponent {
    constructor() {
    }
    set sortDirection(val) {
        this._sortDirection = val;
    }
    get sortDirection() {
        return this._sortDirection;
    }
    ngOnInit() {
    }
};
__decorate([
    Input()
], SortingIconComponent.prototype, "sortDirection", null);
SortingIconComponent = __decorate([
    Component({
        selector: 'shr-sorting-icon',
        template: "<i *ngIf=\"sortDirection === 'asc' || sortDirection === 'ASC'\" class=\"fas fa-sort-amount-up\"></i>\n<i *ngIf=\"sortDirection === 'desc' || sortDirection === 'DESC'\" class=\"fas fa-sort-amount-down\"></i>\n",
        styles: [""]
    })
], SortingIconComponent);

let ShrSortingIconModule = class ShrSortingIconModule {
};
ShrSortingIconModule = __decorate([
    NgModule({
        imports: [
            CommonModule
        ],
        declarations: [SortingIconComponent],
        exports: [
            SortingIconComponent
        ]
    })
], ShrSortingIconModule);

let IfAddModeDirective = class IfAddModeDirective {
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    set nbIfAddMode(actionMode) {
        if (Toolkit2.ActionModeUtil.isAddMode(actionMode)) {
            this.vcRef.clear();
            this.vcRef.createEmbeddedView(this.templateRef);
        }
        else {
            this.vcRef.clear();
        }
    }
};
IfAddModeDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], IfAddModeDirective.prototype, "nbIfAddMode", null);
IfAddModeDirective = __decorate([
    Directive({
        selector: '[nbIfAddMode]'
    })
], IfAddModeDirective);

let IfAddOrViewModeDirective = class IfAddOrViewModeDirective {
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    set nbIfAddOrViewMode(actionMode) {
        if (Toolkit2.ActionModeUtil.isAddOrViewMode(actionMode)) {
            this.vcRef.clear();
            this.vcRef.createEmbeddedView(this.templateRef);
        }
        else {
            this.vcRef.clear();
        }
    }
};
IfAddOrViewModeDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], IfAddOrViewModeDirective.prototype, "nbIfAddOrViewMode", null);
IfAddOrViewModeDirective = __decorate([
    Directive({
        selector: '[nbIfAddOrViewMode]'
    })
], IfAddOrViewModeDirective);

let IfEditModeDirective = class IfEditModeDirective {
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    set nbIfEditMode(actionMode) {
        if (Toolkit2.ActionModeUtil.isEditMode(actionMode)) {
            this.vcRef.clear();
            this.vcRef.createEmbeddedView(this.templateRef);
        }
        else {
            this.vcRef.clear();
        }
    }
};
IfEditModeDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], IfEditModeDirective.prototype, "nbIfEditMode", null);
IfEditModeDirective = __decorate([
    Directive({
        selector: '[nbIfEditMode]'
    })
], IfEditModeDirective);

let IfEditOrAddModeDirective = class IfEditOrAddModeDirective {
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    set nbIfEditOrAddMode(actionMode) {
        if (Toolkit2.ActionModeUtil.isEditOrAddMode(actionMode)) {
            this.vcRef.clear();
            this.vcRef.createEmbeddedView(this.templateRef);
        }
        else {
            this.vcRef.clear();
        }
    }
};
IfEditOrAddModeDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], IfEditOrAddModeDirective.prototype, "nbIfEditOrAddMode", null);
IfEditOrAddModeDirective = __decorate([
    Directive({
        selector: '[nbIfEditOrAddMode]'
    })
], IfEditOrAddModeDirective);

let IfEditOrViewModeDirective = class IfEditOrViewModeDirective {
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    set nbIfEditOrViewMode(actionMode) {
        if (Toolkit2.ActionModeUtil.isEditOrViewMode(actionMode)) {
            this.vcRef.clear();
            this.vcRef.createEmbeddedView(this.templateRef);
        }
        else {
            this.vcRef.clear();
        }
    }
};
IfEditOrViewModeDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], IfEditOrViewModeDirective.prototype, "nbIfEditOrViewMode", null);
IfEditOrViewModeDirective = __decorate([
    Directive({
        selector: '[nbIfEditOrViewMode]'
    })
], IfEditOrViewModeDirective);

let IfViewModeDirective = class IfViewModeDirective {
    constructor(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    set nbIfViewMode(actionMode) {
        if (Toolkit2.ActionModeUtil.isViewMode(actionMode)) {
            this.vcRef.clear();
            this.vcRef.createEmbeddedView(this.templateRef);
        }
        else {
            this.vcRef.clear();
        }
    }
};
IfViewModeDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], IfViewModeDirective.prototype, "nbIfViewMode", null);
IfViewModeDirective = __decorate([
    Directive({
        selector: '[nbIfViewMode]'
    })
], IfViewModeDirective);

let FloatLabelDirective = class FloatLabelDirective {
    constructor(renderer, hostElement) {
        this.renderer = renderer;
        this.hostElement = hostElement;
    }
    onChange() {
        if (this.hostElement.nativeElement.value !== '') {
            this.renderer.addClass(this.hostElement.nativeElement, 'filled');
        }
        else {
            this.renderer.removeClass(this.hostElement.nativeElement, 'filled');
        }
    }
};
FloatLabelDirective.ctorParameters = () => [
    { type: Renderer2 },
    { type: ElementRef }
];
__decorate([
    HostListener('change')
], FloatLabelDirective.prototype, "onChange", null);
FloatLabelDirective = __decorate([
    Directive({
        selector: '[float-label]'
    })
], FloatLabelDirective);

// import {FloatLabelDirective} from './util-directives';
// import {IfAddModeDirective} from './util-directives';
// import {IfAddOrViewModeDirective} from './util-directives';
// import {IfEditModeDirective} from './util-directives';
// import {IfEditOrAddModeDirective} from './util-directives';
// import {IfEditOrViewModeDirective} from './util-directives';
// import {IfViewModeDirective} from './util-directives';
//
// const UtilDirectives = [
//   IfAddModeDirective,
//   IfAddOrViewModeDirective,
//   IfEditModeDirective,
//   IfEditOrAddModeDirective,
//   IfEditOrViewModeDirective,
//   IfViewModeDirective,
//   FloatLabelDirective
// ];
let NbCommonModule = class NbCommonModule {
};
NbCommonModule = __decorate([
    NgModule({
        declarations: [
            CommonComponent,
            IfAddModeDirective,
            IfAddOrViewModeDirective,
            IfEditModeDirective,
            IfEditOrAddModeDirective,
            IfEditOrViewModeDirective,
            IfViewModeDirective,
            FloatLabelDirective
        ],
        imports: [
            ShrPaginationModule,
            ShrSortingIconModule
        ],
        exports: [CommonComponent,
            IfAddModeDirective,
            IfAddOrViewModeDirective,
            IfEditModeDirective,
            IfEditOrAddModeDirective,
            IfEditOrViewModeDirective,
            IfViewModeDirective,
            FloatLabelDirective,
            ShrPaginationModule,
            ShrSortingIconModule]
    })
], NbCommonModule);

class ActionItem {
    constructor(containerSelector, slideNumber, actionMode, queryId, itemIndex) {
        this.containerSelector = containerSelector;
        this.slideNumber = slideNumber;
        this.actionMode = actionMode;
        this.queryId = queryId;
        this.itemIndex = itemIndex;
    }
}

class SectionObject {
    // carouselSelector: string;
    // slideNumber: number;
    // actionMode: ActionMode;
    // id: any = null;
    // index: number = null;
    constructor(carouselSelector, slideNumber, actionMode, id, index) {
        this.carouselSelector = carouselSelector;
        this.slideNumber = slideNumber;
        this.actionMode = actionMode;
        this.id = id;
        this.index = index;
    }
}

class BaseComponentOne {
    constructor() {
        this.selectedActionMode_Out = new EventEmitter();
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    goToSlide(slideNumber) {
        Toolkit2.BootstrapUtil.goToCrouselSlide('#myCarousel', slideNumber);
    }
    goToSection1(carouselSelector, slideNumber, actionMode, id, index, callFunc) {
        if (!isNullOrUndefined(callFunc)) {
            callFunc(actionMode, id, index);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(carouselSelector, slideNumber);
    }
    goToSection(sectionObject, callFunc) {
        this.selectedActionMode = sectionObject.actionMode;
        this.selectedActionMode_Out.emit(sectionObject.actionMode);
        if (!isNullOrUndefined(callFunc)) {
            callFunc(sectionObject.actionMode, sectionObject.id, sectionObject.index);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(sectionObject.carouselSelector, sectionObject.slideNumber);
    }
    goToSection2(sectionObject, callFunc, that) {
        this.selectedActionMode = sectionObject.actionMode;
        this.selectedActionMode_Out.emit(sectionObject.actionMode);
        if (!isNullOrUndefined(that) && !isNullOrUndefined(that.router)) {
            that.router.navigate([], {
                relativeTo: that.activatedRoute,
                queryParams: {
                    target: 'action',
                    actionMode: sectionObject.actionMode,
                    groupId: sectionObject.id
                }
            });
        }
        // that.itemId_Out.emit(sectionObject.id);
        if (!isNullOrUndefined(callFunc)) {
            callFunc(sectionObject.actionMode, sectionObject.id, sectionObject.index, that);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(sectionObject.carouselSelector, sectionObject.slideNumber);
    }
}
__decorate([
    Output()
], BaseComponentOne.prototype, "selectedActionMode_Out", void 0);
__decorate([
    Input()
], BaseComponentOne.prototype, "selectedActionMode_In", void 0);

class BaseActionComponentOne extends BaseComponentOne {
    constructor(activatedRoute, globalConfigurations) {
        super();
        this.activatedRoute = activatedRoute;
        this.globalConfigurations = globalConfigurations;
        this.item_Added_Out = new EventEmitter(null);
        this.item_Edited_Out = new EventEmitter(null);
    }
    lookQueryParams() {
        this.activatedRoute.queryParams.subscribe((params) => {
            const target = params['target'];
            const actionMode = params['actionMode'];
            const itemId = params['itemId'];
            switch (target) {
                case 'action':
                    this.onReceivedItemId(itemId);
                    break;
            }
        });
    }
    applyMode(changeMode) {
        this.actionMode_In = changeMode;
        switch (this.actionMode_In) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode();
                break;
            case ActionMode.VIEW:
                this.onViewMode();
                break;
        }
    }
    afterAdd(form, res, msg = {}) {
        // console.log(res);
        this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd(msg.title, msg.text);
        this.globalConfigurations.successCreate(msg);
    }
    afterEdit(form, res, msg = {}) {
        this.item_Edited_Out.emit(res);
        // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    }
    ngOnChanges(changes) {
        CommonDevTools.Interaction.trackChange(changes);
        if (!isNullOrUndefined(this.actionMode_In)) {
            this.applyMode(this.actionMode_In);
        }
        if (changes.hasOwnProperty('itemId_In') &&
            !isNullOrUndefined(this.itemId_In)) {
            this.onReceivedItemId(this.itemId_In);
        }
        this.onChanges(null);
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        // this.formData.groupFormData.isValidSubmitted = false;
        formIsValidSubmitted = false;
        if (form.invalid) {
            // alert('form is not valid..');
            const notifyConfig = new this.Toolkit2.NotifyConfig(this.Toolkit2.Notify.Type.DANGER, this.Toolkit2.Notify.Placement.TOP_CENTER, this.Toolkit2.Notify.TEMPLATES.Template1, 'فرم معتبر نیست !');
            this.Toolkit2.Notify.showNotify(notifyConfig);
            return;
        }
        // this.formData.groupFormData.isValidSubmitted = true;
        formIsValidSubmitted = true;
        if (this.actionMode_In === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode_In === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    }
}
__decorate([
    Input()
], BaseActionComponentOne.prototype, "itemId_In", void 0);
__decorate([
    Input()
], BaseActionComponentOne.prototype, "actionMode_In", void 0);
__decorate([
    Output()
], BaseActionComponentOne.prototype, "item_Added_Out", void 0);
__decorate([
    Output()
], BaseActionComponentOne.prototype, "item_Edited_Out", void 0);

class BaseAddComponentOne extends BaseComponentOne {
    constructor() {
        super();
        this.addedItem = new EventEmitter();
    }
    afterAdd(addedItem) {
        this.addedItem.emit(addedItem);
    }
}
__decorate([
    Output()
], BaseAddComponentOne.prototype, "addedItem", void 0);

class BaseListComponentOne extends BaseComponentOne {
    constructor() {
        super();
        this.item_Added_In = null;
        this.item_Edited_In = null;
        this.itemId_Out = new EventEmitter();
    }
    deleteItem(id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then((result) => {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    }
    afterDeleteItem(id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    }
    afterCancelDelete() {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    }
    goToSection3(sectionObject, callFunc, that) {
        this.selectedActionMode = sectionObject.actionMode;
        this.selectedActionMode_Out.emit(sectionObject.actionMode);
        if (!isNullOrUndefined(that) && !isNullOrUndefined(that._Router)) {
            that._Router.navigate([], {
                relativeTo: that._ActivatedRoute,
                queryParams: {
                    target: 'action',
                    actionMode: sectionObject.actionMode,
                    itemId: sectionObject.id
                }
            });
        }
        // that.itemId_Out.emit(sectionObject.id);
        if (!isNullOrUndefined(callFunc)) {
            callFunc(sectionObject.actionMode, sectionObject.id, sectionObject.index, that);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(sectionObject.carouselSelector, sectionObject.slideNumber);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        if (changes.hasOwnProperty('item_Added_In') &&
            !isNullOrUndefined(this.item_Added_In)) {
            this.afterAddItem(this.item_Added_In);
            try {
                this.itemId_Out.emit(null);
            }
            catch (e) {
                // console.log('');
            }
            //   alert('Add...');
            //   console.log('this.group_Added_In-->', this.group_Added_In);
        }
        if (changes.hasOwnProperty('item_Edited_In') &&
            !isNullOrUndefined(this.item_Edited_In)) {
            // alert('Edit...');
            // console.log('this.group_Edited_In-->', this.group_Edited_In);
            this.afterEditItem(this.item_Edited_In);
            this.itemId_Out.emit(undefined);
        }
    }
}
__decorate([
    Input()
], BaseListComponentOne.prototype, "item_Added_In", void 0);
__decorate([
    Input()
], BaseListComponentOne.prototype, "item_Edited_In", void 0);
__decorate([
    Output()
], BaseListComponentOne.prototype, "itemId_Out", void 0);

/**
 * @author Jafar Amini in March 2018.
 */
class BaseComponentTwo {
    constructor() {
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
}

class BaseActionComponentTwo extends BaseComponentTwo {
    constructor(activatedRoute, dialogService, globalConfigurations) {
        super();
        this.activatedRoute = activatedRoute;
        this.dialogService = dialogService;
        this.globalConfigurations = globalConfigurations;
    }
    //
    // @Output() item_Added_Out = new EventEmitter<Group>(null);
    // @Output() item_Edited_Out = new EventEmitter<Group>(null);
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
        });
    }
    canDeactivate() {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(changeMode, item) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode(item);
                break;
            case ActionMode.VIEW:
                this.onViewMode(item);
                break;
        }
    }
    afterAdd(form, res, msg = {}) {
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    }
    afterEdit(form, res, msg = {}) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    }
}

class BaseAddComponentTwo extends BaseComponentTwo {
    constructor(activatedRoute, globalConfigurations) {
        super();
        this.activatedRoute = activatedRoute;
        this.globalConfigurations = globalConfigurations;
    }
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.applyMode(data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(item) {
        this.onAddMode();
    }
    afterAdd(form, res, msg = {}) {
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callAddModeSubmit(form, that);
    }
}

class BaseEditComponentTwo extends BaseComponentTwo {
    constructor(activatedRoute, globalConfigurations) {
        super();
        this.activatedRoute = activatedRoute;
        this.globalConfigurations = globalConfigurations;
    }
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.applyMode(data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(item) {
        this.onEditMode(item);
    }
    afterEdit(form, res, msg = {}) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    onSubmit(form, formIsValidSubmitted, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callEditModeSubmit(form, that);
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class BaseListComponentTwo extends BaseComponentTwo {
    constructor() {
        super();
    }
    deleteItem(id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then((result) => {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    }
    afterDeleteItem(id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    }
    afterCancelDelete() {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    }
    ngOnChanges(changes) {
        this.onchanges(changes);
    }
}

class BaseViewComponentTwo extends BaseComponentTwo {
    constructor(_ActivatedRoute) {
        super();
        this._ActivatedRoute = _ActivatedRoute;
    }
    receiveData() {
        this._ActivatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.applyMode(data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this._ActivatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this._ActivatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(item) {
        this.onViewMode(item);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class BaseComponentThree {
    constructor() {
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
}

class BaseActionComponentThree extends BaseComponentThree {
    constructor(activatedRoute, globalConfigurations) {
        super();
        this.activatedRoute = activatedRoute;
        this.globalConfigurations = globalConfigurations;
    }
    //
    // @Output() item_Added_Out = new EventEmitter<Group>(null);
    // @Output() item_Edited_Out = new EventEmitter<Group>(null);
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(changeMode, item) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode(item);
                break;
            case ActionMode.VIEW:
                this.onViewMode(item);
                break;
        }
    }
    afterAdd(form, res, msg = {}) {
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    }
    afterEdit(form, res, msg = {}) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class BaseListComponentThree extends BaseComponentThree {
    constructor() {
        super();
    }
    deleteItem(id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then((result) => {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    }
    afterDeleteItem(id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    }
    afterCancelDelete() {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    }
    ngOnChanges(changes) {
        this.onchanges(changes);
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class BaseComponentFive {
    constructor(_ActivatedRoute) {
        this._ActivatedRoute = _ActivatedRoute;
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    receiveData() {
        this._ActivatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.onReceiveRouteParam(data.modelContainer.routeParams);
            this.onReceiveQueryParam(data.modelContainer.queryParams);
        });
    }
    getQueryParams() {
        return this._ActivatedRoute.snapshot.queryParams;
    }
    getUnFlatQueryParams(clazz, options) {
        return this.getUnFlatQueryParams2(clazz, null, options);
    }
    getUnFlatQueryParams2(clazz, sample, options) {
        const convertCamelToLowerHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this._ActivatedRoute.snapshot.queryParams, clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen });
    }
    getRouteParams() {
        return this._ActivatedRoute.snapshot.paramMap['params'];
    }
    getUnFlatRouteParams(clazz, options) {
        return this.getUnFlatRouteParams2(clazz, null, options);
    }
    getUnFlatRouteParams2(clazz, sample, options) {
        const convertCamelToLowerHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this._ActivatedRoute.snapshot.paramMap['params'], clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen });
    }
    getConvertCamelToLowerHyphen(options) {
        let convertCamelToLowerHyphen = true;
        if (!isNullOrUndefined(options) &&
            !isNullOrUndefined(options.convertCamelToLowerHyphen)) {
            convertCamelToLowerHyphen = options.convertCamelToLowerHyphen;
        }
        else {
            convertCamelToLowerHyphen = true;
        }
        return convertCamelToLowerHyphen;
    }
}

class BaseActionComponentFive extends BaseComponentFive {
    constructor(featurePrefix, activatedRoute, dialogService, globalConfigurations) {
        super(activatedRoute);
        this.featurePrefix = featurePrefix;
        this.activatedRoute = activatedRoute;
        this.dialogService = dialogService;
        this.globalConfigurations = globalConfigurations;
        for (const property of this.Toolkit2.ObjectUtil
            .getObjectPropertyList(this.featurePrefix)) {
            if (this.featurePrefix.hasOwnProperty(property) &&
                activatedRoute.snapshot.params.hasOwnProperty(property)) {
                this.featurePrefix[property] = activatedRoute.snapshot.params[property];
            }
        }
    }
    //
    // @Output() item_Added_Out = new EventEmitter<Group>(null);
    // @Output() item_Edited_Out = new EventEmitter<Group>(null);
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.onReceiveRouteParam(data.modelContainer.routeParams);
            this.onReceiveQueryParam(data.modelContainer.queryParams);
            this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
        });
    }
    canDeactivate() {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(changeMode, item) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode(item);
                break;
            case ActionMode.VIEW:
                this.onViewMode(item);
                break;
        }
    }
    afterAdd(form, res, msg = {}) {
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    }
    afterEdit(form, res, msg = {}) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    }
}

class BaseAddComponentFive extends BaseComponentFive {
    constructor(featurePrefix, activatedRoute, dialogService, globalConfigurations) {
        super(activatedRoute);
        this.featurePrefix = featurePrefix;
        this.activatedRoute = activatedRoute;
        this.dialogService = dialogService;
        this.globalConfigurations = globalConfigurations;
    }
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.onReceiveRouteParam(data.modelContainer.routeParams);
            this.onReceiveQueryParam(data.modelContainer.queryParams);
            this.applyMode(data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(item) {
        this.onAddMode();
    }
    afterAdd(form, res, msg = {}) {
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    canDeactivate() {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callAddModeSubmit(form, that);
    }
}

class BaseEditComponentFive extends BaseComponentFive {
    constructor(featurePrefix, activatedRoute, dialogService, globalConfigurations) {
        super(activatedRoute);
        this.featurePrefix = featurePrefix;
        this.activatedRoute = activatedRoute;
        this.dialogService = dialogService;
        this.globalConfigurations = globalConfigurations;
    }
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.onReceiveRouteParam(data.modelContainer.routeParams);
            this.onReceiveQueryParam(data.modelContainer.queryParams);
            this.applyMode(data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(item) {
        this.onReceivedItem(item);
    }
    afterEdit(form, res, msg = {}) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
    canDeactivate() {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    }
    onSubmit(form, formIsValidSubmitted, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callEditModeSubmit(form, that);
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class BaseListComponentFive extends BaseComponentFive {
    constructor(featurePrefix, _ActivatedRoute) {
        super(_ActivatedRoute);
        this.featurePrefix = featurePrefix;
        this._ActivatedRoute = _ActivatedRoute;
        for (const property of this.Toolkit2.ObjectUtil.getObjectPropertyList(this.featurePrefix)) {
            if (this.featurePrefix.hasOwnProperty(property) &&
                _ActivatedRoute.snapshot.params.hasOwnProperty(property)) {
                this.featurePrefix[property] = _ActivatedRoute.snapshot.params[property];
            }
        }
    }
    deleteItem(id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then((result) => {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    }
    afterDeleteItem(id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    }
    afterCancelDelete() {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    }
    ngOnChanges(changes) {
        this.onchanges(changes);
    }
}

class BaseViewComponentFive extends BaseComponentFive {
    constructor(featurePrefix, _ActivatedRoute) {
        super(_ActivatedRoute);
        this.featurePrefix = featurePrefix;
        this._ActivatedRoute = _ActivatedRoute;
    }
    receiveData() {
        this._ActivatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.onReceiveRouteParam(data.modelContainer.routeParams);
            this.onReceiveQueryParam(data.modelContainer.queryParams);
            this.applyMode(data.modelContainer.item);
        });
    }
    // recieveData() {
    //   this._ActivatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this._ActivatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(item) {
        this.onReceivedItem(item);
    }
    ngOnChanges(changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    }
}

let CanDeactivateGuard = class CanDeactivateGuard {
    canDeactivate(component) {
        if (!component.canDeactivate()) {
            if (confirm('You have unsaved changes! If you leave, your changes will be lost.')) {
                return true;
            }
            else {
                return false;
            }
        }
        return true;
    }
};
CanDeactivateGuard = __decorate([
    Injectable()
], CanDeactivateGuard);

class ComponentCanDeactivate {
    unloadNotification($event) {
        if (!this.canDeactivate()) {
            $event.returnValue = true;
        }
    }
}
__decorate([
    HostListener('window:beforeunload', ['$event'])
], ComponentCanDeactivate.prototype, "unloadNotification", null);

class FormCanDeactivate extends ComponentCanDeactivate {
    canDeactivate() {
        return this.form.submitted || !this.form.dirty;
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class BaseAnyComponentSeven extends ComponentCanDeactivate {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType) {
        super();
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.Toolkit2 = Toolkit2;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.routeParamClazz = new routeParamClazzType;
        this.queryParamClazz = new queryParamClazzType;
    }
    receiveData() {
        // this.route.params
        //   .subscribe((params: Params) => {
        //     this.id = params['id'];
        this.activatedRoute.params.subscribe(params => {
            this.routeParamClazz = new this.routeParamClazzType;
            this.onReceiveRouteParam(this.Toolkit2.ObjectUtil.unFlatify(params, this.routeParamClazz));
        });
        this.activatedRoute.queryParams.subscribe(params => {
            // this.previousQueryParam = JSON.parse(JSON.stringify(this.currentQueryParam));
            // this.currentQueryParam = params;
            this.queryParamClazz = new this.queryParamClazzType;
            this.onReceiveQueryParam(this.Toolkit2.ObjectUtil.unFlatify(params, this.queryParamClazz));
        });
        this.activatedRoute.data
            .subscribe((data) => {
            this.onReceiveRouteData(data);
        });
        // this.onReceiveQueryParam(this.Toolkit2.ObjectUtil.unFlatify(this.activatedRoute.snapshot.queryParams, this.queryParamClazz));
        // this.activatedRoute.data
        //   .subscribe((data: { modelContainer: ModelContainer<T> }) => {
        //     this.onReceivedItem(data.modelContainer.item);
        //   });
        //
        // this.onReceivedItem(data.modelContainer.item);
        // this.activatedRoute.data
        //   .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
        //     // console.log(data);
        //     this.onReceiveRouteParam(data.modelContainer.routeParams);
        //     this.onReceiveQueryParam(data.modelContainer.queryParams);
        //   });
    }
    setToQueryParams(obj, options = {}) {
        if (isNullOrUndefined(options.removeIfEmpty)) {
            options.removeIfEmpty = true;
        }
        obj = this.Toolkit2.ObjectUtil.FlatiFy(new Object(), obj, options.removeIfEmpty);
        // obj = this.overlayValues(obj, this.activatedRoute.snapshot.queryParams);
        this.router.navigate([], {
            relativeTo: this.activatedRoute,
            /**
             * by commented lines clear param problem occur: if in previous query term is "anything" and in new one is null,
             * preivous content remains and can't clean
             */
            // queryParams: {
            //   ...this.activatedRoute.snapshot.queryParams,
            //   ...obj
            // },
            queryParams: Object.assign({}, obj),
            skipLocationChange: options.skipLocationChange,
            replaceUrl: options.replaceUrl,
            queryParamsHandling: 'merge'
        });
    }
    getQueryParams() {
        return this.activatedRoute.snapshot.queryParams;
    }
    getUnFlatQueryParams(clazz, options) {
        return this.getUnFlatQueryParams2(clazz, null, options);
    }
    getUnFlatQueryParams2(clazz, sample, options) {
        const convertCamelToLowerHyphen1 = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.queryParams, clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen1 });
    }
    getRouteParams() {
        return this.activatedRoute.snapshot.paramMap['params'];
    }
    getUnFlatRouteParams(clazz, options) {
        return this.getUnFlatRouteParams2(clazz, null, options);
    }
    getUnFlatRouteParams2(clazz, sample, options) {
        const convertCamelToLHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.paramMap['params'], clazz, sample, { convertCamelToLowerHyphen: convertCamelToLHyphen });
    }
    getConvertCamelToLowerHyphen(options) {
        let convertCamelToLowerHyphen = true;
        if (!isNullOrUndefined(options) &&
            !isNullOrUndefined(options.convertCamelToLowerHyphen)) {
            convertCamelToLowerHyphen = options.convertCamelToLowerHyphen;
        }
        else {
            convertCamelToLowerHyphen = true;
        }
        return convertCamelToLowerHyphen;
    }
}

class BaseActionComponentSeven extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.dialogService = dialogService;
        // actionMode: ActionMode;
        this.addedItem = new EventEmitter(null);
        this.editedItem = new EventEmitter(null);
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    receiveActionMode(afterModeChange) {
        this.activatedRoute.data
            .subscribe((data) => {
            this.actionMode = data.actionMode;
            if (afterModeChange) {
                afterModeChange(this.actionMode);
            }
            this.applyMode(data.actionMode);
        });
    }
    receiveItem() {
        this.activatedRoute.data
            .subscribe((data) => {
            this.onReceivedItem(data.item);
        });
    }
    // canDeactivate(): Observable<boolean> | boolean {
    //   // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
    //   if (!this.getMainObject() ||
    //     JSON.stringify(this.getMainObject()) ===
    //     JSON.stringify(this.getMainObjectInDom())) {
    //     return true;
    //   }
    //   // Otherwise ask the group with the dialog service and return its
    //   // observable which resolves to true or false when the group decides
    //   return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    // }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    applyMode(changeMode) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode();
                break;
            case ActionMode.VIEW:
                this.onViewMode();
                break;
        }
    }
    afterAdd(res, form) {
        // console.log(res);
        this.addedItem.emit(res);
        if (!isNullOrUndefined(form)) {
            form.resetForm();
        }
        // this.Toolkit2.SwalUtil.successAdd();
    }
    afterEdit(res, form) {
        this.editedItem.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
    }
    ngOnChanges(changes) {
        // if (changes.hasOwnProperty('actionMode') || changes.hasOwnProperty('item')) {
        //
        //   this.applyMode(changes['actionMode'].currentValue, this.item);
        // }
        if (changes.hasOwnProperty('actionMode') && !isNullOrUndefined(this.actionMode)) {
            this.applyMode(changes['actionMode'].currentValue);
        }
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        this.onChanges(changes);
    }
    onSubmit(form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
        // // --------------------
        //
        // if (this.actionMode === ActionMode.ADD) {
        //   callAddModeSubmit(form, that);
        // } else if (this.actionMode === ActionMode.EDIT) {
        //   callEditModeSubmit(form, that);
        // }
    }
}
__decorate([
    Input()
], BaseActionComponentSeven.prototype, "item", void 0);
__decorate([
    Input()
], BaseActionComponentSeven.prototype, "actionMode", void 0);
__decorate([
    Output()
], BaseActionComponentSeven.prototype, "addedItem", void 0);
__decorate([
    Output()
], BaseActionComponentSeven.prototype, "editedItem", void 0);

/**
 * @author Jafar Amini in March 2018.
 */
class BaseComponentSeven extends ComponentCanDeactivate {
    constructor(activatedRoute) {
        super();
        this.activatedRoute = activatedRoute;
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    receiveData() {
        this.activatedRoute.data
            .subscribe((data) => {
            // console.log(data);
            this.onReceiveRouteParam(data.modelContainer.routeParams);
            this.onReceiveQueryParam(data.modelContainer.queryParams);
        });
    }
    getQueryParams() {
        return this.activatedRoute.snapshot.queryParams;
    }
    getUnFlatQueryParams(clazz, options) {
        return this.getUnFlatQueryParams2(clazz, null, options);
    }
    getUnFlatQueryParams2(clazz, sample, options) {
        const convertCamelToLowerHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.queryParams, clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen });
    }
    getRouteParams() {
        return this.activatedRoute.snapshot.paramMap['params'];
    }
    getUnFlatRouteParams(clazz, options) {
        return this.getUnFlatRouteParams2(clazz, null, options);
    }
    getUnFlatRouteParams2(clazz, sample, options) {
        const convertCamelToLowerHyphen1 = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.paramMap['params'], clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen1 });
    }
    getConvertCamelToLowerHyphen(options) {
        let convertCamelToLowerHyphen = true;
        if (!isNullOrUndefined(options) &&
            !isNullOrUndefined(options.convertCamelToLowerHyphen)) {
            convertCamelToLowerHyphen = options.convertCamelToLowerHyphen;
        }
        else {
            convertCamelToLowerHyphen = true;
        }
        return convertCamelToLowerHyphen;
    }
}

class BaseCreateComponentSeven extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.dialogService = dialogService;
        this.createdItem = new EventEmitter(null);
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    // canDeactivate(): Observable<boolean> | boolean {
    //   // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
    //   if (!this.getMainObject() ||
    //     JSON.stringify(this.getMainObject()) ===
    //     JSON.stringify(this.getMainObjectInDom())) {
    //     return true;
    //   }
    //   // Otherwise ask the group with the dialog service and return its
    //   // observable which resolves to true or false when the group decides
    //   return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    // }
    afterCreate(res, form) {
        console.log(res);
        this.createdItem.emit(res);
        if (!isNullOrUndefined(form)) {
            form.resetForm();
        }
        // this.Toolkit2.SwalUtil.successAdd();
    }
}
__decorate([
    Output()
], BaseCreateComponentSeven.prototype, "createdItem", void 0);

class BaseEditComponentSeven extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.dialogService = dialogService;
        this.editedItem = new EventEmitter(null);
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    receiveItem() {
        this.activatedRoute.data
            .subscribe((data) => {
            this.onReceivedItem(data.item);
        });
    }
    // canDeactivate(): Observable<boolean> | boolean {
    //   // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
    //   if (!this.getMainObject() ||
    //     JSON.stringify(this.getMainObject()) ===
    //     JSON.stringify(this.getMainObjectInDom())) {
    //     return true;
    //   }
    //   // Otherwise ask the group with the dialog service and return its
    //   // observable which resolves to true or false when the group decides
    //   return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    // }
    afterEdit(res, form) {
        this.editedItem.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
    }
    ngOnChanges(changes) {
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        this.onChanges(changes);
    }
}
__decorate([
    Input()
], BaseEditComponentSeven.prototype, "item", void 0);
__decorate([
    Output()
], BaseEditComponentSeven.prototype, "editedItem", void 0);

var ListMode;
(function (ListMode) {
    ListMode["DEFAULT"] = "DEFAULT";
    ListMode["CHOOSE_ONE"] = "CHOOSE_ONE";
    ListMode["CHOOSE_MULTI"] = "CHOOSE_MULTI";
    ListMode["VIEW"] = "VIEW";
})(ListMode || (ListMode = {}));

class BaseListComponentSeven extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.MyListMode = ListMode;
        this.selectedList = [];
        this.selectedItem = new EventEmitter();
        this.deSelectedItem = new EventEmitter();
        this.firstOnThisRoute = true;
    }
    get listMode() {
        return this._listMode;
    }
    set listMode(val) {
        switch (val) {
            case ListMode.DEFAULT:
                this.onDefaultMode();
                break;
            case ListMode.CHOOSE_ONE:
                this.onChooseOneMode();
                break;
            case ListMode.CHOOSE_MULTI:
                this.onChooseMultiMode();
                break;
        }
        this._listMode = val;
    }
    get triggerData() {
        return this._triggerData;
    }
    set triggerData(value) {
        if (this._triggerData !== value) {
            this.getList();
            this._triggerData = value;
        }
    }
    get itemPage() {
        return this._itemPage;
    }
    set itemPage(val) {
        console.log('itemPage---------------->', val);
        this.getComponentData().itemPage = val;
        if (this.listMode === ListMode.CHOOSE_MULTI) {
            this.getComponentData().itemPage.content.forEach((item, i) => {
                if (!isNullOrUndefined(this.selectedList)) {
                    if (this.selectedList.includes(item)) {
                        item['selected'] = true;
                    }
                }
            });
        }
    }
    getListRemote(optionsOfGetList) {
        this.getListOnCallback()(this.getListRemoteArg(optionsOfGetList));
    }
    getList(optionsOfGetList) {
        this.getComponentData().itemPage = new PageContainer();
        console.log(this.getComponentData().itemPage);
        if (isNullOrUndefined(this.getListOnCallback())) {
            this.getListSelf(optionsOfGetList);
        }
        else {
            this.getListRemote(optionsOfGetList);
        }
    }
    ngOnChanges(changes) {
    }
    onChangeSize(event) {
        this.getComponentData().queryParam.paging.size = event.target.value;
        this.getComponentData().queryParam.paging.page = 0;
        this._setToQueryParams(this.getComponentData().queryParam);
    }
    initiatePagination(value) {
        this.getComponentData().queryParam.paging.page =
            this.getComponentData().queryParamReal.paging.page ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            this.getComponentData().queryParamReal.paging.size ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    }
    resetPagination(value) {
        this.getComponentData().queryParam.paging.page =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    }
    setCurrentPage(page) {
        if (this.getComponentData().queryParamReal.paging.page !== page) {
            this.getComponentData().queryParam.paging.page = page;
            this._setToQueryParams(this.getComponentData().queryParam);
        }
    }
    hardChangeQueryParamReal(queryParam) {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(queryParam));
    }
    hardSyncQueryParamReal() {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(this.getComponentData().queryParam));
    }
    defaultOnReceiveQueryParam(queryParam, optionsOfGetList) {
        if (this.getComponentData().queryParamReal.paging.page !== queryParam.paging.page ||
            this.getComponentData().queryParamReal.paging.size !== queryParam.paging.size) {
            if (this.firstOnThisRoute === false) {
                if (!isNullOrUndefined(queryParam.paging.page)) {
                    this.getComponentData().queryParamReal.paging = JSON.parse(JSON.stringify(queryParam.paging));
                }
                /**
                 * Should remove next line
                 */
                this.getList(optionsOfGetList);
            }
            else {
                this.firstOnThisRoute = false;
            }
        }
        if (this.getComponentData().queryParamReal.itemId !== queryParam.itemId) {
            this.getComponentData().queryParamReal.itemId = queryParam.itemId;
        }
    }
    defaultOnReceiveRouteParam() {
        this.firstOnThisRoute = true;
    }
    defaultSortify(sortings, event) {
        console.log(event.target.attributes.field);
        console.log(event.target.attributes.sortdirection);
        switch (event.target.attributes.sortdirection) {
            case 'null':
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
            case 'asc':
                event.target.attributes.sortdirection = 'desc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'desc'] });
                break;
            case 'desc':
                event.target.attributes.sortdirection = 'null';
                sortings = [];
                break;
            default:
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
        }
        return sortings;
    }
    processPage(optionsOfGetList) {
        if (this.getComponentData().itemPage.content.length <= 0) {
            if (this.getComponentData().itemPage.last) {
                if (this.getComponentData().queryParamReal.paging.page > 0) {
                    this.getComponentData().queryParam.paging.page--;
                    this._setToQueryParams(this.getComponentData().queryParam);
                }
            }
            else {
                this.getList(optionsOfGetList);
            }
        }
    }
}
__decorate([
    Input()
], BaseListComponentSeven.prototype, "selectedList", void 0);
__decorate([
    Input()
], BaseListComponentSeven.prototype, "listMode", null);
__decorate([
    Input()
], BaseListComponentSeven.prototype, "triggerData", null);
__decorate([
    Input()
], BaseListComponentSeven.prototype, "itemPage", null);
__decorate([
    Output()
], BaseListComponentSeven.prototype, "selectedItem", void 0);
__decorate([
    Output()
], BaseListComponentSeven.prototype, "deSelectedItem", void 0);

class BaseListComponentSeven2 extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.MyListMode = ListMode;
        this.selectedList = [];
        this.serviceIsRemote = false;
        this.callRemoteService = new EventEmitter();
        this.selectedItem = new EventEmitter();
        this.deSelectedItem = new EventEmitter();
        this.firstOnThisRoute = true;
    }
    get listMode() {
        return this._listMode;
    }
    set listMode(val) {
        switch (val) {
            case ListMode.DEFAULT:
                this.onDefaultMode();
                break;
            case ListMode.CHOOSE_ONE:
                this.onChooseOneMode();
                break;
            case ListMode.CHOOSE_MULTI:
                this.onChooseMultiMode();
                break;
        }
        this._listMode = val;
    }
    get triggerData() {
        return this._triggerData;
    }
    set triggerData(value) {
        if (this._triggerData !== value) {
            this.getList();
            this._triggerData = value;
        }
    }
    get itemPage() {
        return this._itemPage;
    }
    set itemPage(val) {
        console.log('itemPage---------------->', val);
        this.getComponentData().itemPage = val;
        if (this.listMode === ListMode.CHOOSE_MULTI) {
            this.getComponentData().itemPage.content.forEach((item, i) => {
                if (!isNullOrUndefined(this.selectedList)) {
                    if (this.selectedList.includes(item)) {
                        item['selected'] = true;
                    }
                }
            });
        }
    }
    getListRemote(optionsOfGetList) {
        this.callRemoteService.emit(this.getListRemoteArg(optionsOfGetList));
    }
    getList(optionsOfGetList) {
        this.getComponentData().itemPage = new PageContainer();
        console.log(this.getComponentData().itemPage);
        if (!this.serviceIsRemote) {
            this.getListSelf(optionsOfGetList);
        }
        else {
            this.getListRemote(optionsOfGetList);
        }
    }
    ngOnChanges(changes) {
    }
    onChangeSize(event) {
        this.getComponentData().queryParam.paging.size = event.target.value;
        this.getComponentData().queryParam.paging.page = 0;
        this._setToQueryParams(this.getComponentData().queryParam);
    }
    initiatePagination(value) {
        this.getComponentData().queryParam.paging.page =
            this.getComponentData().queryParamReal.paging.page ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            this.getComponentData().queryParamReal.paging.size ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    }
    resetPagination(value) {
        this.getComponentData().queryParam.paging.page =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    }
    setCurrentPage(page) {
        if (this.getComponentData().queryParamReal.paging.page !== page) {
            this.getComponentData().queryParam.paging.page = page;
            this._setToQueryParams(this.getComponentData().queryParam);
        }
    }
    setCurrentSize(size) {
        if (this.getComponentData().queryParamReal.paging.size !== size) {
            this.getComponentData().queryParam.paging.size = size;
            this._setToQueryParams(this.getComponentData().queryParam);
        }
    }
    getCurrentPage() {
        return this.getComponentData().queryParamReal.paging.page;
    }
    hardChangeQueryParamReal(queryParam) {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(queryParam));
    }
    hardSyncQueryParamReal() {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(this.getComponentData().queryParam));
    }
    defaultOnReceiveQueryParam(queryParam, optionsOfGetList) {
        if (this.getComponentData().queryParamReal.paging.page !== queryParam.paging.page ||
            this.getComponentData().queryParamReal.paging.size !== queryParam.paging.size) {
            if (this.firstOnThisRoute === false) {
                if (!isNullOrUndefined(queryParam.paging.page)) {
                    this.getComponentData().queryParamReal.paging = JSON.parse(JSON.stringify(queryParam.paging));
                }
                /**
                 * Should remove next line
                 */
                this.getList(optionsOfGetList);
            }
            else {
                this.firstOnThisRoute = false;
            }
        }
        if (this.getComponentData().queryParamReal.itemId !== queryParam.itemId) {
            this.getComponentData().queryParamReal.itemId = queryParam.itemId;
        }
    }
    defaultOnReceiveRouteParam() {
        this.firstOnThisRoute = true;
    }
    defaultSortify(sortings, event) {
        console.log(event.target.attributes.field);
        console.log(event.target.attributes.sortdirection);
        switch (event.target.attributes.sortdirection) {
            case 'null':
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
            case 'asc':
                event.target.attributes.sortdirection = 'desc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'desc'] });
                break;
            case 'desc':
                event.target.attributes.sortdirection = 'null';
                sortings = [];
                break;
            default:
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
        }
        return sortings;
    }
    processPage(optionsOfGetList) {
        if (this.getComponentData().itemPage.content.length <= 0) {
            if (this.getComponentData().itemPage.last) {
                if (this.getComponentData().queryParamReal.paging.page > 0) {
                    this.getComponentData().queryParam.paging.page--;
                    this._setToQueryParams(this.getComponentData().queryParam);
                }
            }
            else {
                this.getList(optionsOfGetList);
            }
        }
    }
}
__decorate([
    Input()
], BaseListComponentSeven2.prototype, "selectedList", void 0);
__decorate([
    Input()
], BaseListComponentSeven2.prototype, "serviceIsRemote", void 0);
__decorate([
    Output()
], BaseListComponentSeven2.prototype, "callRemoteService", void 0);
__decorate([
    Input()
], BaseListComponentSeven2.prototype, "listMode", null);
__decorate([
    Input()
], BaseListComponentSeven2.prototype, "triggerData", null);
__decorate([
    Input()
], BaseListComponentSeven2.prototype, "itemPage", null);
__decorate([
    Output()
], BaseListComponentSeven2.prototype, "selectedItem", void 0);
__decorate([
    Output()
], BaseListComponentSeven2.prototype, "deSelectedItem", void 0);

class BaseReceiverComponentSeven extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.dialogService = dialogService;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    receiveItem() {
        this.activatedRoute.data
            .subscribe((data) => {
            this.onReceivedItem(data.item);
        });
    }
    ngOnChanges(changes) {
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        this.onChanges(changes);
    }
}
__decorate([
    Input()
], BaseReceiverComponentSeven.prototype, "item", void 0);

class BaseViewComponentSeven extends BaseAnyComponentSeven {
    constructor(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        super(activatedRoute, router, routeParamClazzType, queryParamClazzType);
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.dialogService = dialogService;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    receiveItem() {
        this.activatedRoute.data
            .subscribe((data) => {
            this.onReceivedItem(data.item);
        });
    }
    ngOnChanges(changes) {
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        this.onChanges(changes);
    }
}
__decorate([
    Input()
], BaseViewComponentSeven.prototype, "item", void 0);

class ListComponentData {
    constructor(routeParamClazzType, queryParamClazzType) {
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.sizeList = [5, 10, 15, 20, 25];
        this.queryParam = new queryParamClazzType();
        this.routeParam = new routeParamClazzType();
        this.queryParamReal = new queryParamClazzType();
        this.routeParamReal = new routeParamClazzType();
        this.itemPage = new PageContainer();
        this.itemPage.content = [];
        this.sortings = [];
    }
    init(init) {
        if (!isNullOrUndefined(init)) {
            this.sortings = init.sortings || [];
            this.term = init.term || '';
            this.sizeList = init.sizeList || [5, 10, 15, 20, 25];
        }
    }
}

class ListQueryParam {
    constructor() {
        this.paging = new Paging();
        this.itemId = null;
        this.term = null;
    }
}

class ModelContainer {
    constructor(routeParams, queryParams, item, actionMode) {
        this.item = item;
        this.routeParams = routeParams;
        this.queryParams = queryParams;
        this.actionMode = actionMode;
    }
}

class BaseActionResolver {
    constructor(router, _GlobalConfigurations) {
        this.router = router;
        this._GlobalConfigurations = _GlobalConfigurations;
    }
    resolve(route, state) {
        this.actionMode = route.paramMap.get('actionMode');
        // if (itemId !== this._GlobalConfigurations.getRoutingNoArgument()) {
        //   return this.callResolveService(route.paramMap['params'], itemId);
        return this.callResolveService(route.paramMap['params'], route.queryParams);
        // } else {
        //   return this.retResolved(null);
        // }
    }
    retResolved(routeParams, queryParams, res) {
        const modelContainer = new ModelContainer(routeParams);
        modelContainer.actionMode = ActionMode[this.actionMode];
        modelContainer.routeParams = routeParams;
        modelContainer.queryParams = queryParams;
        if (res) {
            modelContainer.item = res;
            // alert('waaaw, modelContainer: ' + JSON.stringify(modelContainer));
        }
        else { // id not found
            modelContainer.item = null;
        }
        return modelContainer;
    }
}

class BaseAnyResolver {
    constructor(router) {
        this.router = router;
    }
    resolve(route, state) {
        return this.callResolveService(route);
    }
    retResolved(res) {
        return res;
    }
}

class BaseReceiveResolver {
    constructor(router, _GlobalConfigurations) {
        this.router = router;
        this._GlobalConfigurations = _GlobalConfigurations;
    }
    resolve(route, state) {
        // if (itemId !== this._GlobalConfigurations.getRoutingNoArgument()) {
        //   return this.callResolveService(route.paramMap['params'], itemId);
        return this.callResolveService(route.paramMap['params'], route.queryParams);
        // } else {
        //   return this.retResolved(null);
        // }
    }
    retResolved(routeParams, queryParams, res) {
        const modelContainer = new ModelContainer(routeParams);
        modelContainer.routeParams = routeParams;
        modelContainer.queryParams = queryParams;
        if (res) {
            modelContainer.item = res;
            // alert('waaaw, modelContainer: ' + JSON.stringify(modelContainer));
        }
        else { // id not found
            modelContainer.item = null;
        }
        return modelContainer;
    }
}

/*
 * Public API Surface of common
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ActionItem, BaseActionComponentFive, BaseActionComponentOne, BaseActionComponentSeven, BaseActionComponentThree, BaseActionComponentTwo, BaseActionResolver, BaseAddComponentFive, BaseAddComponentOne, BaseAddComponentTwo, BaseAnyComponentSeven, BaseAnyResolver, BaseComponentFive, BaseComponentOne, BaseComponentSeven, BaseComponentThree, BaseComponentTwo, BaseCreateComponentSeven, BaseEditComponentFive, BaseEditComponentSeven, BaseEditComponentTwo, BaseListComponentFive, BaseListComponentOne, BaseListComponentSeven, BaseListComponentSeven2, BaseListComponentThree, BaseListComponentTwo, BaseReceiveResolver, BaseReceiverComponentSeven, BaseViewComponentFive, BaseViewComponentSeven, BaseViewComponentTwo, CanDeactivateGuard, CommonComponent, CommonService, ComponentCanDeactivate, FormCanDeactivate, ListComponentData, ListMode, ListQueryParam, NbCommonModule, SectionObject, ShrPaginationEvent, IfAddModeDirective as ɵa, IfAddOrViewModeDirective as ɵb, IfEditModeDirective as ɵc, IfEditOrAddModeDirective as ɵd, IfEditOrViewModeDirective as ɵe, IfViewModeDirective as ɵf, FloatLabelDirective as ɵg, ShrPaginationModule as ɵh, PaginationComponent as ɵi, ShrSortingIconModule as ɵj, SortingIconComponent as ɵk, ComponentCanDeactivate as ɵl };
//# sourceMappingURL=angular-boot-common.js.map
