import { __decorate, __extends, __values, __assign } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, EventEmitter, Input, Output, NgModule, TemplateRef, ViewContainerRef, Directive, Renderer2, ElementRef, HostListener } from '@angular/core';
import { CommonModule } from '@angular/common';
import { isNullOrUndefined, Toolkit2, UtilModule, ActionMode, CommonDevTools, PageContainer, Paging } from '@angular-boot/util';
import { FormsModule } from '@angular/forms';
import swal from 'sweetalert2';

var ShrPaginationEvent = /** @class */ (function () {
    function ShrPaginationEvent(page, size) {
        this.page = page;
        this.size = size;
    }
    return ShrPaginationEvent;
}());

var CommonService = /** @class */ (function () {
    function CommonService() {
    }
    CommonService.ngInjectableDef = ɵɵdefineInjectable({ factory: function CommonService_Factory() { return new CommonService(); }, token: CommonService, providedIn: "root" });
    CommonService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], CommonService);
    return CommonService;
}());

var CommonComponent = /** @class */ (function () {
    function CommonComponent() {
    }
    CommonComponent.prototype.ngOnInit = function () {
    };
    CommonComponent = __decorate([
        Component({
            selector: 'lib-common',
            template: "\n    <p>\n      common works!\n    </p>\n  "
        })
    ], CommonComponent);
    return CommonComponent;
}());

var PaginationComponent = /** @class */ (function () {
    // @Output() indicatorCountChange: EventEmitter<number> = new EventEmitter<number>();
    function PaginationComponent() {
        this.size = 5;
        this.showTotalPage = true;
        this.showSizeSelection = true;
        this.sizeSelectionArray = [5, 10, 20, 50];
        this.defaultSizeIndex = 0;
        // private _currentPage: number;
        // @Input()
        // set currentPage(val) {
        //   console.log('set currentPage');
        //   this._currentPage = val;
        //   this.initiateCurrentIndicator(this._currentPage);
        // }
        //
        // get currentPage(): number {
        //   return this._currentPage;
        // }
        this.indicates = [];
        this.pageSizeChange = new EventEmitter();
        /**
         * @Deprecated use currentPageChange instead
         */
        this.selectedPage = new EventEmitter();
        this.currentPageChange = new EventEmitter();
        this.sizeChange = new EventEmitter();
    }
    PaginationComponent.prototype.ngOnInit = function () {
        this.indicatorCount = this.indicatorCount || 5;
        this.calculateOffset();
        // this.initiateCurrentIndicator(this._currentPage);
        this.initiateCurrentIndicator(this.currentPage);
        this.generateIndicates();
    };
    PaginationComponent.prototype.generateIndicates = function () {
        this.indicates = [];
        for (var i = this.offset; i < this.offset + this.indicatorCount; i++) {
            if (i <= this.totalPages) {
                this.indicates.push(i);
            }
        }
    };
    PaginationComponent.prototype.initiateCurrentIndicator = function (i) {
        this.currentIndicator = +(i || 0) + 1;
    };
    PaginationComponent.prototype.setCurrentIndicator = function (i) {
        this.currentIndicator = i;
        this.emitSelectedPage(this.currentIndicator - 1);
    };
    PaginationComponent.prototype.nextimize = function () {
        if (this.offset + this.indicatorCount <= this.totalPages) {
            this.offset = this.offset + this.indicatorCount;
            this.setCurrentIndicator(this.offset);
        }
        else {
            if (this.currentIndicator < this.totalPages) {
                this.setCurrentIndicator(this.currentIndicator + 1);
            }
        }
        this.generateIndicates();
    };
    PaginationComponent.prototype.previmize = function () {
        if (this.offset - this.indicatorCount >= 1) {
            this.offset = this.offset - this.indicatorCount;
            this.setCurrentIndicator(this.offset + this.indicatorCount - 1);
        }
        else {
            if (this.currentIndicator > 1) {
                this.setCurrentIndicator(this.currentIndicator - 1);
            }
        }
        this.generateIndicates();
    };
    PaginationComponent.prototype.reFirst = function () {
        this.offset = 1;
        this.setCurrentIndicator(1);
        this.generateIndicates();
    };
    PaginationComponent.prototype.reLast = function () {
        this.setCurrentIndicator(this.totalPages);
        var co = Math.trunc(this.totalPages / this.indicatorCount);
        if (co * this.indicatorCount === this.totalPages) {
            this.offset = this.totalPages - this.indicatorCount + 1;
        }
        else {
            this.offset = (co * this.indicatorCount) + 1;
        }
        this.generateIndicates();
    };
    PaginationComponent.prototype.childNgOnChanges = function (changes) {
        for (var propName in changes) {
            if (changes.hasOwnProperty(propName)) {
                this.onChange(propName, changes);
            }
        }
    };
    PaginationComponent.prototype.ngOnChanges = function (changes) {
        this.childNgOnChanges(changes);
    };
    PaginationComponent.prototype.onChange = function (propName, changes) {
        switch (propName) {
            case 'currentPage':
                // console.log('set currentPage');
                this.initiateCurrentIndicator(this.currentPage);
                this.generateIndicates();
                break;
            case 'totalPages':
                if (!isNullOrUndefined(this.totalPages)) {
                    this.generateIndicates();
                }
                break;
            case 'defaultSizeIndex':
                if (!isNullOrUndefined(this.defaultSizeIndex)) {
                    if (this.defaultSizeIndex < 0) {
                        this.defaultSizeIndex = 0;
                        throw new Error('defaultSizeIndex should not be less than 0');
                    }
                    else if (this.defaultSizeIndex >= this.sizeSelectionArray.length) {
                        this.defaultSizeIndex = this.sizeSelectionArray.length - 1;
                        throw new Error('defaultSizeIndex should not be less than 0');
                    }
                    this.size = this.sizeSelectionArray[this.defaultSizeIndex];
                }
                break;
        }
    };
    PaginationComponent.prototype.en2Fa = function (value) {
        return Toolkit2.Common.En2Fa(value);
    };
    PaginationComponent.prototype.emitSelectedPage = function (page) {
        this.currentPage = page;
        this.currentPageChange.emit(page);
        this.selectedPage.emit(page);
        this.pageSizeChange.emit(new ShrPaginationEvent(page, this.size));
    };
    PaginationComponent.prototype.onSizeChange = function (event) {
        console.log(event);
        this.sizeChange.emit(event);
        // console.log('prev size: ', this.size);
        // console.log('current size: ', event);
        if (event > this.size) { // if current_size is larger than prev_size
            this.currentPage = Math.floor(this.currentPage / Math.ceil(event / this.size));
        }
        this.calculateOffset();
        this.pageSizeChange.emit(new ShrPaginationEvent(this.currentPage, event));
    };
    PaginationComponent.prototype.calculateOffset = function () {
        this.offset = Math.floor(this.currentPage / this.indicatorCount) * this.indicatorCount + 1;
    };
    __decorate([
        Input()
    ], PaginationComponent.prototype, "size", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "offset", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "indicatorCount", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "showTotalPage", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "showSizeSelection", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "sizeSelectionArray", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "defaultSizeIndex", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "totalPages", void 0);
    __decorate([
        Input()
    ], PaginationComponent.prototype, "currentPage", void 0);
    __decorate([
        Output()
    ], PaginationComponent.prototype, "pageSizeChange", void 0);
    __decorate([
        Output()
    ], PaginationComponent.prototype, "selectedPage", void 0);
    __decorate([
        Output()
    ], PaginationComponent.prototype, "currentPageChange", void 0);
    __decorate([
        Output()
    ], PaginationComponent.prototype, "sizeChange", void 0);
    PaginationComponent = __decorate([
        Component({
            selector: 'shr-pagination',
            template: "<!--Pagination 1-->\n<nav class=\"Pager1\" aria-label=\"pagination example\">\n  <div class=\"d-flex justify-content-between align-items-center\">\n    <div class=\"\">\n      <span *ngIf=\"showTotalPage\">\u0635\u0641\u062D\u0647 {{+currentPage + 1 | nbpipe: en2Fa}} \u0627\u0632 {{totalPages | nbpipe: en2Fa}}</span>\n    </div>\n    <div class=\"\">\n      <ul class=\"pagination pagination-circle justify-content-center\">\n\n        <!--First-->\n        <li class=\"page-item\"\n            [ngClass]=\"{disabled: currentIndicator === 1, 'cursor-pointer': currentIndicator !== 1}\">\n          <a class=\"page-link\" (click)=\"reFirst()\">\u0627\u0648\u0644\u06CC\u0646</a>\n        </li>\n\n        <!--Arrow left-->\n        <li class=\"page-item\" [ngClass]=\"{disabled: currentIndicator === 1, 'cursor-pointer': currentIndicator !== 1}\">\n          <a class=\"page-link\" aria-label=\"Previous\" (click)=\"previmize()\">\n            <span aria-hidden=\"true\">&laquo;</span>\n            <span class=\"sr-only\">Previous</span>\n          </a>\n        </li>\n\n        <!--Numbers-->\n        <ng-container *ngFor=\"let i of indicates\">\n          <li class=\"page-item\" [ngClass]=\"{'active': i === currentIndicator}\" style=\"cursor: pointer;\">\n            <a class=\"page-link\" (click)=\"setCurrentIndicator(i)\">{{i}}</a>\n          </li>\n        </ng-container>\n        <!--Arrow right-->\n        <li class=\"page-item\" [ngClass]=\"{disabled: currentIndicator === totalPages, 'cursor-pointer': currentIndicator !== totalPages}\">\n          <a class=\"page-link\" aria-label=\"Next\" (click)=\"nextimize()\">\n            <span aria-hidden=\"true\">&raquo;</span>\n            <span class=\"sr-only\">Next</span>\n          </a>\n        </li>\n\n        <!--Last-->\n        <li class=\"page-item\"\n            [ngClass]=\"{disabled: currentIndicator === totalPages, 'cursor-pointer': currentIndicator !== totalPages}\">\n          <a class=\"page-link\" (click)=\"reLast()\">\u0622\u062E\u0631\u06CC\u0646</a>\n        </li>\n      </ul>\n    </div>\n    <div class=\"col-2\">\n      <ng-container *ngIf=\"showSizeSelection\">\n        <!--        <ng-select id=\"size\" name=\"size\" [(ngModel)]=\"size\" (change)=\"onSizeChange($event)\">-->\n        <!--          <ng-option *ngFor=\"let item of sizeSelectionArray\" [value]=\"item\"> {{item}}</ng-option>-->\n        <!--        </ng-select>-->\n        <select id=\"size\" name=\"size\" class=\"form-control\" (ngModelChange)=\"onSizeChange($event)\" [(ngModel)]=\"size\">\n          <option *ngFor=\"let item of sizeSelectionArray\" [value]=\"item\"> {{item}}</option>\n        </select>\n      </ng-container>\n    </div>\n  </div>\n</nav>\n",
            styles: ["nav{margin:10px auto 0}.pagination.pagination-circle .page-item.active .page-link{border-radius:50%}.pagination .page-item .page-link:hover{transition:.3s linear;border-radius:.125rem;background-color:#ccc}.pagination{margin-top:15px}.pagination.pg-blue .page-item.active .page-link:hover{background-color:#bd5410}.pagination .page-item.active .page-link{transition:.2s linear;border-radius:.125rem;background-color:#bd5410;color:#fff;box-shadow:0 2px 5px 0 rgba(0,0,0,.16),0 2px 10px 0 rgba(0,0,0,.12)}.pagination .page-item .page-link{border-radius:.125rem;transition:.3s linear;outline:0;border:0;background-color:transparent;font-size:.9rem;color:#999;font-weight:700}.pagination.pagination-circle .page-item .page-link:hover{border-radius:50%}.pagination.pagination-circle .page-item .page-link{margin-left:2px;margin-right:2px;border-radius:50%}.page-link{border:none!important}"]
        })
    ], PaginationComponent);
    return PaginationComponent;
}());

var ShrPaginationModule = /** @class */ (function () {
    function ShrPaginationModule() {
    }
    ShrPaginationModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                UtilModule,
                FormsModule
            ],
            declarations: [PaginationComponent],
            exports: [
                PaginationComponent
            ]
        })
    ], ShrPaginationModule);
    return ShrPaginationModule;
}());

var SortingIconComponent = /** @class */ (function () {
    function SortingIconComponent() {
    }
    Object.defineProperty(SortingIconComponent.prototype, "sortDirection", {
        get: function () {
            return this._sortDirection;
        },
        set: function (val) {
            this._sortDirection = val;
        },
        enumerable: true,
        configurable: true
    });
    SortingIconComponent.prototype.ngOnInit = function () {
    };
    __decorate([
        Input()
    ], SortingIconComponent.prototype, "sortDirection", null);
    SortingIconComponent = __decorate([
        Component({
            selector: 'shr-sorting-icon',
            template: "<i *ngIf=\"sortDirection === 'asc' || sortDirection === 'ASC'\" class=\"fas fa-sort-amount-up\"></i>\n<i *ngIf=\"sortDirection === 'desc' || sortDirection === 'DESC'\" class=\"fas fa-sort-amount-down\"></i>\n",
            styles: [""]
        })
    ], SortingIconComponent);
    return SortingIconComponent;
}());

var ShrSortingIconModule = /** @class */ (function () {
    function ShrSortingIconModule() {
    }
    ShrSortingIconModule = __decorate([
        NgModule({
            imports: [
                CommonModule
            ],
            declarations: [SortingIconComponent],
            exports: [
                SortingIconComponent
            ]
        })
    ], ShrSortingIconModule);
    return ShrSortingIconModule;
}());

var IfAddModeDirective = /** @class */ (function () {
    function IfAddModeDirective(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    Object.defineProperty(IfAddModeDirective.prototype, "nbIfAddMode", {
        set: function (actionMode) {
            if (Toolkit2.ActionModeUtil.isAddMode(actionMode)) {
                this.vcRef.clear();
                this.vcRef.createEmbeddedView(this.templateRef);
            }
            else {
                this.vcRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    IfAddModeDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], IfAddModeDirective.prototype, "nbIfAddMode", null);
    IfAddModeDirective = __decorate([
        Directive({
            selector: '[nbIfAddMode]'
        })
    ], IfAddModeDirective);
    return IfAddModeDirective;
}());

var IfAddOrViewModeDirective = /** @class */ (function () {
    function IfAddOrViewModeDirective(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    Object.defineProperty(IfAddOrViewModeDirective.prototype, "nbIfAddOrViewMode", {
        set: function (actionMode) {
            if (Toolkit2.ActionModeUtil.isAddOrViewMode(actionMode)) {
                this.vcRef.clear();
                this.vcRef.createEmbeddedView(this.templateRef);
            }
            else {
                this.vcRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    IfAddOrViewModeDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], IfAddOrViewModeDirective.prototype, "nbIfAddOrViewMode", null);
    IfAddOrViewModeDirective = __decorate([
        Directive({
            selector: '[nbIfAddOrViewMode]'
        })
    ], IfAddOrViewModeDirective);
    return IfAddOrViewModeDirective;
}());

var IfEditModeDirective = /** @class */ (function () {
    function IfEditModeDirective(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    Object.defineProperty(IfEditModeDirective.prototype, "nbIfEditMode", {
        set: function (actionMode) {
            if (Toolkit2.ActionModeUtil.isEditMode(actionMode)) {
                this.vcRef.clear();
                this.vcRef.createEmbeddedView(this.templateRef);
            }
            else {
                this.vcRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    IfEditModeDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], IfEditModeDirective.prototype, "nbIfEditMode", null);
    IfEditModeDirective = __decorate([
        Directive({
            selector: '[nbIfEditMode]'
        })
    ], IfEditModeDirective);
    return IfEditModeDirective;
}());

var IfEditOrAddModeDirective = /** @class */ (function () {
    function IfEditOrAddModeDirective(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    Object.defineProperty(IfEditOrAddModeDirective.prototype, "nbIfEditOrAddMode", {
        set: function (actionMode) {
            if (Toolkit2.ActionModeUtil.isEditOrAddMode(actionMode)) {
                this.vcRef.clear();
                this.vcRef.createEmbeddedView(this.templateRef);
            }
            else {
                this.vcRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    IfEditOrAddModeDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], IfEditOrAddModeDirective.prototype, "nbIfEditOrAddMode", null);
    IfEditOrAddModeDirective = __decorate([
        Directive({
            selector: '[nbIfEditOrAddMode]'
        })
    ], IfEditOrAddModeDirective);
    return IfEditOrAddModeDirective;
}());

var IfEditOrViewModeDirective = /** @class */ (function () {
    function IfEditOrViewModeDirective(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    Object.defineProperty(IfEditOrViewModeDirective.prototype, "nbIfEditOrViewMode", {
        set: function (actionMode) {
            if (Toolkit2.ActionModeUtil.isEditOrViewMode(actionMode)) {
                this.vcRef.clear();
                this.vcRef.createEmbeddedView(this.templateRef);
            }
            else {
                this.vcRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    IfEditOrViewModeDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], IfEditOrViewModeDirective.prototype, "nbIfEditOrViewMode", null);
    IfEditOrViewModeDirective = __decorate([
        Directive({
            selector: '[nbIfEditOrViewMode]'
        })
    ], IfEditOrViewModeDirective);
    return IfEditOrViewModeDirective;
}());

var IfViewModeDirective = /** @class */ (function () {
    function IfViewModeDirective(templateRef, vcRef) {
        this.templateRef = templateRef;
        this.vcRef = vcRef;
    }
    Object.defineProperty(IfViewModeDirective.prototype, "nbIfViewMode", {
        set: function (actionMode) {
            if (Toolkit2.ActionModeUtil.isViewMode(actionMode)) {
                this.vcRef.clear();
                this.vcRef.createEmbeddedView(this.templateRef);
            }
            else {
                this.vcRef.clear();
            }
        },
        enumerable: true,
        configurable: true
    });
    IfViewModeDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    __decorate([
        Input()
    ], IfViewModeDirective.prototype, "nbIfViewMode", null);
    IfViewModeDirective = __decorate([
        Directive({
            selector: '[nbIfViewMode]'
        })
    ], IfViewModeDirective);
    return IfViewModeDirective;
}());

var FloatLabelDirective = /** @class */ (function () {
    function FloatLabelDirective(renderer, hostElement) {
        this.renderer = renderer;
        this.hostElement = hostElement;
    }
    FloatLabelDirective.prototype.onChange = function () {
        if (this.hostElement.nativeElement.value !== '') {
            this.renderer.addClass(this.hostElement.nativeElement, 'filled');
        }
        else {
            this.renderer.removeClass(this.hostElement.nativeElement, 'filled');
        }
    };
    FloatLabelDirective.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    __decorate([
        HostListener('change')
    ], FloatLabelDirective.prototype, "onChange", null);
    FloatLabelDirective = __decorate([
        Directive({
            selector: '[float-label]'
        })
    ], FloatLabelDirective);
    return FloatLabelDirective;
}());

// import {FloatLabelDirective} from './util-directives';
// import {IfAddModeDirective} from './util-directives';
// import {IfAddOrViewModeDirective} from './util-directives';
// import {IfEditModeDirective} from './util-directives';
// import {IfEditOrAddModeDirective} from './util-directives';
// import {IfEditOrViewModeDirective} from './util-directives';
// import {IfViewModeDirective} from './util-directives';
//
// const UtilDirectives = [
//   IfAddModeDirective,
//   IfAddOrViewModeDirective,
//   IfEditModeDirective,
//   IfEditOrAddModeDirective,
//   IfEditOrViewModeDirective,
//   IfViewModeDirective,
//   FloatLabelDirective
// ];
var NbCommonModule = /** @class */ (function () {
    function NbCommonModule() {
    }
    NbCommonModule = __decorate([
        NgModule({
            declarations: [
                CommonComponent,
                IfAddModeDirective,
                IfAddOrViewModeDirective,
                IfEditModeDirective,
                IfEditOrAddModeDirective,
                IfEditOrViewModeDirective,
                IfViewModeDirective,
                FloatLabelDirective
            ],
            imports: [
                ShrPaginationModule,
                ShrSortingIconModule
            ],
            exports: [CommonComponent,
                IfAddModeDirective,
                IfAddOrViewModeDirective,
                IfEditModeDirective,
                IfEditOrAddModeDirective,
                IfEditOrViewModeDirective,
                IfViewModeDirective,
                FloatLabelDirective,
                ShrPaginationModule,
                ShrSortingIconModule]
        })
    ], NbCommonModule);
    return NbCommonModule;
}());

var ActionItem = /** @class */ (function () {
    function ActionItem(containerSelector, slideNumber, actionMode, queryId, itemIndex) {
        this.containerSelector = containerSelector;
        this.slideNumber = slideNumber;
        this.actionMode = actionMode;
        this.queryId = queryId;
        this.itemIndex = itemIndex;
    }
    return ActionItem;
}());

var SectionObject = /** @class */ (function () {
    // carouselSelector: string;
    // slideNumber: number;
    // actionMode: ActionMode;
    // id: any = null;
    // index: number = null;
    function SectionObject(carouselSelector, slideNumber, actionMode, id, index) {
        this.carouselSelector = carouselSelector;
        this.slideNumber = slideNumber;
        this.actionMode = actionMode;
        this.id = id;
        this.index = index;
    }
    return SectionObject;
}());

var BaseComponentOne = /** @class */ (function () {
    function BaseComponentOne() {
        this.selectedActionMode_Out = new EventEmitter();
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    BaseComponentOne.prototype.goToSlide = function (slideNumber) {
        Toolkit2.BootstrapUtil.goToCrouselSlide('#myCarousel', slideNumber);
    };
    BaseComponentOne.prototype.goToSection1 = function (carouselSelector, slideNumber, actionMode, id, index, callFunc) {
        if (!isNullOrUndefined(callFunc)) {
            callFunc(actionMode, id, index);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(carouselSelector, slideNumber);
    };
    BaseComponentOne.prototype.goToSection = function (sectionObject, callFunc) {
        this.selectedActionMode = sectionObject.actionMode;
        this.selectedActionMode_Out.emit(sectionObject.actionMode);
        if (!isNullOrUndefined(callFunc)) {
            callFunc(sectionObject.actionMode, sectionObject.id, sectionObject.index);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(sectionObject.carouselSelector, sectionObject.slideNumber);
    };
    BaseComponentOne.prototype.goToSection2 = function (sectionObject, callFunc, that) {
        this.selectedActionMode = sectionObject.actionMode;
        this.selectedActionMode_Out.emit(sectionObject.actionMode);
        if (!isNullOrUndefined(that) && !isNullOrUndefined(that.router)) {
            that.router.navigate([], {
                relativeTo: that.activatedRoute,
                queryParams: {
                    target: 'action',
                    actionMode: sectionObject.actionMode,
                    groupId: sectionObject.id
                }
            });
        }
        // that.itemId_Out.emit(sectionObject.id);
        if (!isNullOrUndefined(callFunc)) {
            callFunc(sectionObject.actionMode, sectionObject.id, sectionObject.index, that);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(sectionObject.carouselSelector, sectionObject.slideNumber);
    };
    __decorate([
        Output()
    ], BaseComponentOne.prototype, "selectedActionMode_Out", void 0);
    __decorate([
        Input()
    ], BaseComponentOne.prototype, "selectedActionMode_In", void 0);
    return BaseComponentOne;
}());

var BaseActionComponentOne = /** @class */ (function (_super) {
    __extends(BaseActionComponentOne, _super);
    function BaseActionComponentOne(activatedRoute, globalConfigurations) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.globalConfigurations = globalConfigurations;
        _this.item_Added_Out = new EventEmitter(null);
        _this.item_Edited_Out = new EventEmitter(null);
        return _this;
    }
    BaseActionComponentOne.prototype.lookQueryParams = function () {
        var _this = this;
        this.activatedRoute.queryParams.subscribe(function (params) {
            var target = params['target'];
            var actionMode = params['actionMode'];
            var itemId = params['itemId'];
            switch (target) {
                case 'action':
                    _this.onReceivedItemId(itemId);
                    break;
            }
        });
    };
    BaseActionComponentOne.prototype.applyMode = function (changeMode) {
        this.actionMode_In = changeMode;
        switch (this.actionMode_In) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode();
                break;
            case ActionMode.VIEW:
                this.onViewMode();
                break;
        }
    };
    BaseActionComponentOne.prototype.afterAdd = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        // console.log(res);
        this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd(msg.title, msg.text);
        this.globalConfigurations.successCreate(msg);
    };
    BaseActionComponentOne.prototype.afterEdit = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        this.item_Edited_Out.emit(res);
        // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    };
    BaseActionComponentOne.prototype.ngOnChanges = function (changes) {
        CommonDevTools.Interaction.trackChange(changes);
        if (!isNullOrUndefined(this.actionMode_In)) {
            this.applyMode(this.actionMode_In);
        }
        if (changes.hasOwnProperty('itemId_In') &&
            !isNullOrUndefined(this.itemId_In)) {
            this.onReceivedItemId(this.itemId_In);
        }
        this.onChanges(null);
    };
    BaseActionComponentOne.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        // this.formData.groupFormData.isValidSubmitted = false;
        formIsValidSubmitted = false;
        if (form.invalid) {
            // alert('form is not valid..');
            var notifyConfig = new this.Toolkit2.NotifyConfig(this.Toolkit2.Notify.Type.DANGER, this.Toolkit2.Notify.Placement.TOP_CENTER, this.Toolkit2.Notify.TEMPLATES.Template1, 'فرم معتبر نیست !');
            this.Toolkit2.Notify.showNotify(notifyConfig);
            return;
        }
        // this.formData.groupFormData.isValidSubmitted = true;
        formIsValidSubmitted = true;
        if (this.actionMode_In === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode_In === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    };
    __decorate([
        Input()
    ], BaseActionComponentOne.prototype, "itemId_In", void 0);
    __decorate([
        Input()
    ], BaseActionComponentOne.prototype, "actionMode_In", void 0);
    __decorate([
        Output()
    ], BaseActionComponentOne.prototype, "item_Added_Out", void 0);
    __decorate([
        Output()
    ], BaseActionComponentOne.prototype, "item_Edited_Out", void 0);
    return BaseActionComponentOne;
}(BaseComponentOne));

var BaseAddComponentOne = /** @class */ (function (_super) {
    __extends(BaseAddComponentOne, _super);
    function BaseAddComponentOne() {
        var _this = _super.call(this) || this;
        _this.addedItem = new EventEmitter();
        return _this;
    }
    BaseAddComponentOne.prototype.afterAdd = function (addedItem) {
        this.addedItem.emit(addedItem);
    };
    __decorate([
        Output()
    ], BaseAddComponentOne.prototype, "addedItem", void 0);
    return BaseAddComponentOne;
}(BaseComponentOne));

var BaseListComponentOne = /** @class */ (function (_super) {
    __extends(BaseListComponentOne, _super);
    function BaseListComponentOne() {
        var _this = _super.call(this) || this;
        _this.item_Added_In = null;
        _this.item_Edited_In = null;
        _this.itemId_Out = new EventEmitter();
        return _this;
    }
    BaseListComponentOne.prototype.deleteItem = function (id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then(function (result) {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    };
    BaseListComponentOne.prototype.afterDeleteItem = function (id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    };
    BaseListComponentOne.prototype.afterCancelDelete = function () {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    };
    BaseListComponentOne.prototype.goToSection3 = function (sectionObject, callFunc, that) {
        this.selectedActionMode = sectionObject.actionMode;
        this.selectedActionMode_Out.emit(sectionObject.actionMode);
        if (!isNullOrUndefined(that) && !isNullOrUndefined(that._Router)) {
            that._Router.navigate([], {
                relativeTo: that._ActivatedRoute,
                queryParams: {
                    target: 'action',
                    actionMode: sectionObject.actionMode,
                    itemId: sectionObject.id
                }
            });
        }
        // that.itemId_Out.emit(sectionObject.id);
        if (!isNullOrUndefined(callFunc)) {
            callFunc(sectionObject.actionMode, sectionObject.id, sectionObject.index, that);
        }
        Toolkit2.BootstrapUtil.goToCrouselSlide(sectionObject.carouselSelector, sectionObject.slideNumber);
    };
    BaseListComponentOne.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        if (changes.hasOwnProperty('item_Added_In') &&
            !isNullOrUndefined(this.item_Added_In)) {
            this.afterAddItem(this.item_Added_In);
            try {
                this.itemId_Out.emit(null);
            }
            catch (e) {
                // console.log('');
            }
            //   alert('Add...');
            //   console.log('this.group_Added_In-->', this.group_Added_In);
        }
        if (changes.hasOwnProperty('item_Edited_In') &&
            !isNullOrUndefined(this.item_Edited_In)) {
            // alert('Edit...');
            // console.log('this.group_Edited_In-->', this.group_Edited_In);
            this.afterEditItem(this.item_Edited_In);
            this.itemId_Out.emit(undefined);
        }
    };
    __decorate([
        Input()
    ], BaseListComponentOne.prototype, "item_Added_In", void 0);
    __decorate([
        Input()
    ], BaseListComponentOne.prototype, "item_Edited_In", void 0);
    __decorate([
        Output()
    ], BaseListComponentOne.prototype, "itemId_Out", void 0);
    return BaseListComponentOne;
}(BaseComponentOne));

/**
 * @author Jafar Amini in March 2018.
 */
var BaseComponentTwo = /** @class */ (function () {
    function BaseComponentTwo() {
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    return BaseComponentTwo;
}());

var BaseActionComponentTwo = /** @class */ (function (_super) {
    __extends(BaseActionComponentTwo, _super);
    function BaseActionComponentTwo(activatedRoute, dialogService, globalConfigurations) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.dialogService = dialogService;
        _this.globalConfigurations = globalConfigurations;
        return _this;
    }
    //
    // @Output() item_Added_Out = new EventEmitter<Group>(null);
    // @Output() item_Edited_Out = new EventEmitter<Group>(null);
    BaseActionComponentTwo.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
        });
    };
    BaseActionComponentTwo.prototype.canDeactivate = function () {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseActionComponentTwo.prototype.applyMode = function (changeMode, item) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode(item);
                break;
            case ActionMode.VIEW:
                this.onViewMode(item);
                break;
        }
    };
    BaseActionComponentTwo.prototype.afterAdd = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    };
    BaseActionComponentTwo.prototype.afterEdit = function (form, res, msg) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        if (msg === void 0) { msg = {}; }
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    };
    BaseActionComponentTwo.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseActionComponentTwo.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    };
    return BaseActionComponentTwo;
}(BaseComponentTwo));

var BaseAddComponentTwo = /** @class */ (function (_super) {
    __extends(BaseAddComponentTwo, _super);
    function BaseAddComponentTwo(activatedRoute, globalConfigurations) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.globalConfigurations = globalConfigurations;
        return _this;
    }
    BaseAddComponentTwo.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.applyMode(data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseAddComponentTwo.prototype.applyMode = function (item) {
        this.onAddMode();
    };
    BaseAddComponentTwo.prototype.afterAdd = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    };
    BaseAddComponentTwo.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseAddComponentTwo.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callAddModeSubmit(form, that);
    };
    return BaseAddComponentTwo;
}(BaseComponentTwo));

var BaseEditComponentTwo = /** @class */ (function (_super) {
    __extends(BaseEditComponentTwo, _super);
    function BaseEditComponentTwo(activatedRoute, globalConfigurations) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.globalConfigurations = globalConfigurations;
        return _this;
    }
    BaseEditComponentTwo.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.applyMode(data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseEditComponentTwo.prototype.applyMode = function (item) {
        this.onEditMode(item);
    };
    BaseEditComponentTwo.prototype.afterEdit = function (form, res, msg) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        if (msg === void 0) { msg = {}; }
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    };
    BaseEditComponentTwo.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseEditComponentTwo.prototype.onSubmit = function (form, formIsValidSubmitted, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callEditModeSubmit(form, that);
    };
    return BaseEditComponentTwo;
}(BaseComponentTwo));

var BaseListComponentTwo = /** @class */ (function (_super) {
    __extends(BaseListComponentTwo, _super);
    function BaseListComponentTwo() {
        return _super.call(this) || this;
    }
    BaseListComponentTwo.prototype.deleteItem = function (id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then(function (result) {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    };
    BaseListComponentTwo.prototype.afterDeleteItem = function (id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    };
    BaseListComponentTwo.prototype.afterCancelDelete = function () {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    };
    BaseListComponentTwo.prototype.ngOnChanges = function (changes) {
        this.onchanges(changes);
    };
    return BaseListComponentTwo;
}(BaseComponentTwo));

var BaseViewComponentTwo = /** @class */ (function (_super) {
    __extends(BaseViewComponentTwo, _super);
    function BaseViewComponentTwo(_ActivatedRoute) {
        var _this = _super.call(this) || this;
        _this._ActivatedRoute = _ActivatedRoute;
        return _this;
    }
    BaseViewComponentTwo.prototype.receiveData = function () {
        var _this = this;
        this._ActivatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.applyMode(data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this._ActivatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this._ActivatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseViewComponentTwo.prototype.applyMode = function (item) {
        this.onViewMode(item);
    };
    BaseViewComponentTwo.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    return BaseViewComponentTwo;
}(BaseComponentTwo));

/**
 * @author Jafar Amini in March 2018.
 */
var BaseComponentThree = /** @class */ (function () {
    function BaseComponentThree() {
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    return BaseComponentThree;
}());

var BaseActionComponentThree = /** @class */ (function (_super) {
    __extends(BaseActionComponentThree, _super);
    function BaseActionComponentThree(activatedRoute, globalConfigurations) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.globalConfigurations = globalConfigurations;
        return _this;
    }
    //
    // @Output() item_Added_Out = new EventEmitter<Group>(null);
    // @Output() item_Edited_Out = new EventEmitter<Group>(null);
    BaseActionComponentThree.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseActionComponentThree.prototype.applyMode = function (changeMode, item) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode(item);
                break;
            case ActionMode.VIEW:
                this.onViewMode(item);
                break;
        }
    };
    BaseActionComponentThree.prototype.afterAdd = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    };
    BaseActionComponentThree.prototype.afterEdit = function (form, res, msg) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        if (msg === void 0) { msg = {}; }
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    };
    BaseActionComponentThree.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseActionComponentThree.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    };
    return BaseActionComponentThree;
}(BaseComponentThree));

var BaseListComponentThree = /** @class */ (function (_super) {
    __extends(BaseListComponentThree, _super);
    function BaseListComponentThree() {
        return _super.call(this) || this;
    }
    BaseListComponentThree.prototype.deleteItem = function (id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then(function (result) {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    };
    BaseListComponentThree.prototype.afterDeleteItem = function (id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    };
    BaseListComponentThree.prototype.afterCancelDelete = function () {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    };
    BaseListComponentThree.prototype.ngOnChanges = function (changes) {
        this.onchanges(changes);
    };
    return BaseListComponentThree;
}(BaseComponentThree));

/**
 * @author Jafar Amini in March 2018.
 */
var BaseComponentFive = /** @class */ (function () {
    function BaseComponentFive(_ActivatedRoute) {
        this._ActivatedRoute = _ActivatedRoute;
        this.Toolkit2 = Toolkit2;
        this.ActionMode = ActionMode;
    }
    BaseComponentFive.prototype.receiveData = function () {
        var _this = this;
        this._ActivatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.onReceiveRouteParam(data.modelContainer.routeParams);
            _this.onReceiveQueryParam(data.modelContainer.queryParams);
        });
    };
    BaseComponentFive.prototype.getQueryParams = function () {
        return this._ActivatedRoute.snapshot.queryParams;
    };
    BaseComponentFive.prototype.getUnFlatQueryParams = function (clazz, options) {
        return this.getUnFlatQueryParams2(clazz, null, options);
    };
    BaseComponentFive.prototype.getUnFlatQueryParams2 = function (clazz, sample, options) {
        var convertCamelToLowerHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this._ActivatedRoute.snapshot.queryParams, clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen });
    };
    BaseComponentFive.prototype.getRouteParams = function () {
        return this._ActivatedRoute.snapshot.paramMap['params'];
    };
    BaseComponentFive.prototype.getUnFlatRouteParams = function (clazz, options) {
        return this.getUnFlatRouteParams2(clazz, null, options);
    };
    BaseComponentFive.prototype.getUnFlatRouteParams2 = function (clazz, sample, options) {
        var convertCamelToLowerHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this._ActivatedRoute.snapshot.paramMap['params'], clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen });
    };
    BaseComponentFive.prototype.getConvertCamelToLowerHyphen = function (options) {
        var convertCamelToLowerHyphen = true;
        if (!isNullOrUndefined(options) &&
            !isNullOrUndefined(options.convertCamelToLowerHyphen)) {
            convertCamelToLowerHyphen = options.convertCamelToLowerHyphen;
        }
        else {
            convertCamelToLowerHyphen = true;
        }
        return convertCamelToLowerHyphen;
    };
    return BaseComponentFive;
}());

var BaseActionComponentFive = /** @class */ (function (_super) {
    __extends(BaseActionComponentFive, _super);
    function BaseActionComponentFive(featurePrefix, activatedRoute, dialogService, globalConfigurations) {
        var e_1, _a;
        var _this = _super.call(this, activatedRoute) || this;
        _this.featurePrefix = featurePrefix;
        _this.activatedRoute = activatedRoute;
        _this.dialogService = dialogService;
        _this.globalConfigurations = globalConfigurations;
        try {
            for (var _b = __values(_this.Toolkit2.ObjectUtil
                .getObjectPropertyList(_this.featurePrefix)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var property = _c.value;
                if (_this.featurePrefix.hasOwnProperty(property) &&
                    activatedRoute.snapshot.params.hasOwnProperty(property)) {
                    _this.featurePrefix[property] = activatedRoute.snapshot.params[property];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return _this;
    }
    //
    // @Output() item_Added_Out = new EventEmitter<Group>(null);
    // @Output() item_Edited_Out = new EventEmitter<Group>(null);
    BaseActionComponentFive.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.onReceiveRouteParam(data.modelContainer.routeParams);
            _this.onReceiveQueryParam(data.modelContainer.queryParams);
            _this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
        });
    };
    BaseActionComponentFive.prototype.canDeactivate = function () {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseActionComponentFive.prototype.applyMode = function (changeMode, item) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode(item);
                break;
            case ActionMode.VIEW:
                this.onViewMode(item);
                break;
        }
    };
    BaseActionComponentFive.prototype.afterAdd = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    };
    BaseActionComponentFive.prototype.afterEdit = function (form, res, msg) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        if (msg === void 0) { msg = {}; }
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    };
    BaseActionComponentFive.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseActionComponentFive.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
    };
    return BaseActionComponentFive;
}(BaseComponentFive));

var BaseAddComponentFive = /** @class */ (function (_super) {
    __extends(BaseAddComponentFive, _super);
    function BaseAddComponentFive(featurePrefix, activatedRoute, dialogService, globalConfigurations) {
        var _this = _super.call(this, activatedRoute) || this;
        _this.featurePrefix = featurePrefix;
        _this.activatedRoute = activatedRoute;
        _this.dialogService = dialogService;
        _this.globalConfigurations = globalConfigurations;
        return _this;
    }
    BaseAddComponentFive.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.onReceiveRouteParam(data.modelContainer.routeParams);
            _this.onReceiveQueryParam(data.modelContainer.queryParams);
            _this.applyMode(data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseAddComponentFive.prototype.applyMode = function (item) {
        this.onAddMode();
    };
    BaseAddComponentFive.prototype.afterAdd = function (form, res, msg) {
        if (msg === void 0) { msg = {}; }
        // console.log(res);
        // this.item_Added_Out.emit(res);
        form.resetForm();
        // this.Toolkit2.SwalUtil.successAdd();
        this.globalConfigurations.successCreate(msg);
    };
    BaseAddComponentFive.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseAddComponentFive.prototype.canDeactivate = function () {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    };
    BaseAddComponentFive.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callAddModeSubmit(form, that);
    };
    return BaseAddComponentFive;
}(BaseComponentFive));

var BaseEditComponentFive = /** @class */ (function (_super) {
    __extends(BaseEditComponentFive, _super);
    function BaseEditComponentFive(featurePrefix, activatedRoute, dialogService, globalConfigurations) {
        var _this = _super.call(this, activatedRoute) || this;
        _this.featurePrefix = featurePrefix;
        _this.activatedRoute = activatedRoute;
        _this.dialogService = dialogService;
        _this.globalConfigurations = globalConfigurations;
        return _this;
    }
    BaseEditComponentFive.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.onReceiveRouteParam(data.modelContainer.routeParams);
            _this.onReceiveQueryParam(data.modelContainer.queryParams);
            _this.applyMode(data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseEditComponentFive.prototype.applyMode = function (item) {
        this.onReceivedItem(item);
    };
    BaseEditComponentFive.prototype.afterEdit = function (form, res, msg) {
        // this.item_Edited_Out.emit(res);
        // // form.resetForm();
        if (msg === void 0) { msg = {}; }
        // this.Toolkit2.SwalUtil.successEdit();
        this.globalConfigurations.successEdit(msg);
    };
    BaseEditComponentFive.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    BaseEditComponentFive.prototype.canDeactivate = function () {
        // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
        if (!this.getMainObject() ||
            JSON.stringify(this.getMainObject()) ===
                JSON.stringify(this.getMainObjectInDom())) {
            return true;
        }
        // Otherwise ask the group with the dialog service and return its
        // observable which resolves to true or false when the group decides
        return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    };
    BaseEditComponentFive.prototype.onSubmit = function (form, formIsValidSubmitted, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        callEditModeSubmit(form, that);
    };
    return BaseEditComponentFive;
}(BaseComponentFive));

var BaseListComponentFive = /** @class */ (function (_super) {
    __extends(BaseListComponentFive, _super);
    function BaseListComponentFive(featurePrefix, _ActivatedRoute) {
        var e_1, _a;
        var _this = _super.call(this, _ActivatedRoute) || this;
        _this.featurePrefix = featurePrefix;
        _this._ActivatedRoute = _ActivatedRoute;
        try {
            for (var _b = __values(_this.Toolkit2.ObjectUtil.getObjectPropertyList(_this.featurePrefix)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var property = _c.value;
                if (_this.featurePrefix.hasOwnProperty(property) &&
                    _ActivatedRoute.snapshot.params.hasOwnProperty(property)) {
                    _this.featurePrefix[property] = _ActivatedRoute.snapshot.params[property];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return _this;
    }
    BaseListComponentFive.prototype.deleteItem = function (id, i, callback) {
        swal({
            showCloseButton: true,
            showCancelButton: true,
            background: '#e4e4e4',
            cancelButtonColor: '#04383c',
            confirmButtonColor: '#04383c',
            title: 'آیا از حذف این مورد مطمئن هستید؟',
            text: 'شما قادر به بازگردانی این مورد نخواهید بود!',
            type: 'warning',
            cancelButtonText: 'خیر',
            confirmButtonText: 'بله، حذف شود'
        }).then(function (result) {
            if (result.value) {
                callback(id, i);
            }
            else if (result.dismiss) {
                window['this'].afterCancelDelete();
            }
        });
    };
    BaseListComponentFive.prototype.afterDeleteItem = function (id, i) {
        // swal(
        //   'Deleted!',
        //   'Your imaginary file has been deleted.',
        //   'success'
        // );
        swal({
            title: 'حذف شد',
            text: 'سطر مورد نظر حذف شد',
            type: 'success',
            showCloseButton: true,
            confirmButtonColor: '#04383c',
            background: '#e4e4e4',
            confirmButtonText: 'تایید'
        });
    };
    BaseListComponentFive.prototype.afterCancelDelete = function () {
        // swal(
        //   'Cancelled',
        //   'Your imaginary file is safe :)',
        //   'error'
        // );
        swal.mixin();
    };
    BaseListComponentFive.prototype.ngOnChanges = function (changes) {
        this.onchanges(changes);
    };
    return BaseListComponentFive;
}(BaseComponentFive));

var BaseViewComponentFive = /** @class */ (function (_super) {
    __extends(BaseViewComponentFive, _super);
    function BaseViewComponentFive(featurePrefix, _ActivatedRoute) {
        var _this = _super.call(this, _ActivatedRoute) || this;
        _this.featurePrefix = featurePrefix;
        _this._ActivatedRoute = _ActivatedRoute;
        return _this;
    }
    BaseViewComponentFive.prototype.receiveData = function () {
        var _this = this;
        this._ActivatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.onReceiveRouteParam(data.modelContainer.routeParams);
            _this.onReceiveQueryParam(data.modelContainer.queryParams);
            _this.applyMode(data.modelContainer.item);
        });
    };
    // recieveData() {
    //   this._ActivatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this._ActivatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseViewComponentFive.prototype.applyMode = function (item) {
        this.onReceivedItem(item);
    };
    BaseViewComponentFive.prototype.ngOnChanges = function (changes) {
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        // this.onChanges(null);
    };
    return BaseViewComponentFive;
}(BaseComponentFive));

var CanDeactivateGuard = /** @class */ (function () {
    function CanDeactivateGuard() {
    }
    CanDeactivateGuard.prototype.canDeactivate = function (component) {
        if (!component.canDeactivate()) {
            if (confirm('You have unsaved changes! If you leave, your changes will be lost.')) {
                return true;
            }
            else {
                return false;
            }
        }
        return true;
    };
    CanDeactivateGuard = __decorate([
        Injectable()
    ], CanDeactivateGuard);
    return CanDeactivateGuard;
}());

var ComponentCanDeactivate = /** @class */ (function () {
    function ComponentCanDeactivate() {
    }
    ComponentCanDeactivate.prototype.unloadNotification = function ($event) {
        if (!this.canDeactivate()) {
            $event.returnValue = true;
        }
    };
    __decorate([
        HostListener('window:beforeunload', ['$event'])
    ], ComponentCanDeactivate.prototype, "unloadNotification", null);
    return ComponentCanDeactivate;
}());

var FormCanDeactivate = /** @class */ (function (_super) {
    __extends(FormCanDeactivate, _super);
    function FormCanDeactivate() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormCanDeactivate.prototype.canDeactivate = function () {
        return this.form.submitted || !this.form.dirty;
    };
    return FormCanDeactivate;
}(ComponentCanDeactivate));

var BaseAnyComponentSeven = /** @class */ (function (_super) {
    __extends(BaseAnyComponentSeven, _super);
    function BaseAnyComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.Toolkit2 = Toolkit2;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.routeParamClazz = new routeParamClazzType;
        _this.queryParamClazz = new queryParamClazzType;
        return _this;
    }
    BaseAnyComponentSeven.prototype.receiveData = function () {
        // this.route.params
        //   .subscribe((params: Params) => {
        //     this.id = params['id'];
        var _this = this;
        this.activatedRoute.params.subscribe(function (params) {
            _this.routeParamClazz = new _this.routeParamClazzType;
            _this.onReceiveRouteParam(_this.Toolkit2.ObjectUtil.unFlatify(params, _this.routeParamClazz));
        });
        this.activatedRoute.queryParams.subscribe(function (params) {
            // this.previousQueryParam = JSON.parse(JSON.stringify(this.currentQueryParam));
            // this.currentQueryParam = params;
            _this.queryParamClazz = new _this.queryParamClazzType;
            _this.onReceiveQueryParam(_this.Toolkit2.ObjectUtil.unFlatify(params, _this.queryParamClazz));
        });
        this.activatedRoute.data
            .subscribe(function (data) {
            _this.onReceiveRouteData(data);
        });
        // this.onReceiveQueryParam(this.Toolkit2.ObjectUtil.unFlatify(this.activatedRoute.snapshot.queryParams, this.queryParamClazz));
        // this.activatedRoute.data
        //   .subscribe((data: { modelContainer: ModelContainer<T> }) => {
        //     this.onReceivedItem(data.modelContainer.item);
        //   });
        //
        // this.onReceivedItem(data.modelContainer.item);
        // this.activatedRoute.data
        //   .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
        //     // console.log(data);
        //     this.onReceiveRouteParam(data.modelContainer.routeParams);
        //     this.onReceiveQueryParam(data.modelContainer.queryParams);
        //   });
    };
    BaseAnyComponentSeven.prototype.setToQueryParams = function (obj, options) {
        if (options === void 0) { options = {}; }
        if (isNullOrUndefined(options.removeIfEmpty)) {
            options.removeIfEmpty = true;
        }
        obj = this.Toolkit2.ObjectUtil.FlatiFy(new Object(), obj, options.removeIfEmpty);
        // obj = this.overlayValues(obj, this.activatedRoute.snapshot.queryParams);
        this.router.navigate([], {
            relativeTo: this.activatedRoute,
            /**
             * by commented lines clear param problem occur: if in previous query term is "anything" and in new one is null,
             * preivous content remains and can't clean
             */
            // queryParams: {
            //   ...this.activatedRoute.snapshot.queryParams,
            //   ...obj
            // },
            queryParams: __assign({}, obj),
            skipLocationChange: options.skipLocationChange,
            replaceUrl: options.replaceUrl,
            queryParamsHandling: 'merge'
        });
    };
    BaseAnyComponentSeven.prototype.getQueryParams = function () {
        return this.activatedRoute.snapshot.queryParams;
    };
    BaseAnyComponentSeven.prototype.getUnFlatQueryParams = function (clazz, options) {
        return this.getUnFlatQueryParams2(clazz, null, options);
    };
    BaseAnyComponentSeven.prototype.getUnFlatQueryParams2 = function (clazz, sample, options) {
        var convertCamelToLowerHyphen1 = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.queryParams, clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen1 });
    };
    BaseAnyComponentSeven.prototype.getRouteParams = function () {
        return this.activatedRoute.snapshot.paramMap['params'];
    };
    BaseAnyComponentSeven.prototype.getUnFlatRouteParams = function (clazz, options) {
        return this.getUnFlatRouteParams2(clazz, null, options);
    };
    BaseAnyComponentSeven.prototype.getUnFlatRouteParams2 = function (clazz, sample, options) {
        var convertCamelToLHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.paramMap['params'], clazz, sample, { convertCamelToLowerHyphen: convertCamelToLHyphen });
    };
    BaseAnyComponentSeven.prototype.getConvertCamelToLowerHyphen = function (options) {
        var convertCamelToLowerHyphen = true;
        if (!isNullOrUndefined(options) &&
            !isNullOrUndefined(options.convertCamelToLowerHyphen)) {
            convertCamelToLowerHyphen = options.convertCamelToLowerHyphen;
        }
        else {
            convertCamelToLowerHyphen = true;
        }
        return convertCamelToLowerHyphen;
    };
    return BaseAnyComponentSeven;
}(ComponentCanDeactivate));

var BaseActionComponentSeven = /** @class */ (function (_super) {
    __extends(BaseActionComponentSeven, _super);
    function BaseActionComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.dialogService = dialogService;
        // actionMode: ActionMode;
        _this.addedItem = new EventEmitter(null);
        _this.editedItem = new EventEmitter(null);
        return _this;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    BaseActionComponentSeven.prototype.receiveActionMode = function (afterModeChange) {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            _this.actionMode = data.actionMode;
            if (afterModeChange) {
                afterModeChange(_this.actionMode);
            }
            _this.applyMode(data.actionMode);
        });
    };
    BaseActionComponentSeven.prototype.receiveItem = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            _this.onReceivedItem(data.item);
        });
    };
    // canDeactivate(): Observable<boolean> | boolean {
    //   // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
    //   if (!this.getMainObject() ||
    //     JSON.stringify(this.getMainObject()) ===
    //     JSON.stringify(this.getMainObjectInDom())) {
    //     return true;
    //   }
    //   // Otherwise ask the group with the dialog service and return its
    //   // observable which resolves to true or false when the group decides
    //   return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    // }
    // recieveData() {
    //   this.activatedRoute.data
    //     .subscribe((data: { modelContainer: ModelContainer<Object> }) => {
    //       // console.log(data);
    //       this.applyMode(data.modelContainer.actionMode, data.modelContainer.item);
    //     });
    // }
    // lookQueryParams() {
    //   this.activatedRoute.queryParams.subscribe((params) => {
    //     const target = params['target'];
    //     const actionMode = params['actionMode'];
    //     const itemId = params['itemId'];
    //     switch (target) {
    //       case 'action':
    //         this.onReceivedItemId(itemId);
    //         break;
    //     }
    //   });
    // }
    BaseActionComponentSeven.prototype.applyMode = function (changeMode) {
        // alert('in applyMode()   this.actionMode = ' + this.actionMode);
        this.actionMode = changeMode;
        switch (this.actionMode) {
            case ActionMode.ADD:
                this.onAddMode();
                break;
            case ActionMode.EDIT:
                this.onEditMode();
                break;
            case ActionMode.VIEW:
                this.onViewMode();
                break;
        }
    };
    BaseActionComponentSeven.prototype.afterAdd = function (res, form) {
        // console.log(res);
        this.addedItem.emit(res);
        if (!isNullOrUndefined(form)) {
            form.resetForm();
        }
        // this.Toolkit2.SwalUtil.successAdd();
    };
    BaseActionComponentSeven.prototype.afterEdit = function (res, form) {
        this.editedItem.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
    };
    BaseActionComponentSeven.prototype.ngOnChanges = function (changes) {
        // if (changes.hasOwnProperty('actionMode') || changes.hasOwnProperty('item')) {
        //
        //   this.applyMode(changes['actionMode'].currentValue, this.item);
        // }
        if (changes.hasOwnProperty('actionMode') && !isNullOrUndefined(this.actionMode)) {
            this.applyMode(changes['actionMode'].currentValue);
        }
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        // CommonDevTools.Interaction.trackChange(changes);
        // if (!isNullOrUndefined(this.actionMode_In)) {
        //   this.applyMode(this.actionMode_In);
        // }
        // if (changes.hasOwnProperty('itemId_In') &&
        //   !isNullOrUndefined(this.itemId_In)
        // ) {
        //   this.onReceivedItemId(this.itemId_In);
        //
        // }
        this.onChanges(changes);
    };
    BaseActionComponentSeven.prototype.onSubmit = function (form, formIsValidSubmitted, callAddModeSubmit, callEditModeSubmit, that) {
        formIsValidSubmitted = false;
        if (form.invalid) {
            alert('form is not valid..');
            return;
        }
        formIsValidSubmitted = true;
        if (this.actionMode === ActionMode.ADD) {
            callAddModeSubmit(form, that);
        }
        else if (this.actionMode === ActionMode.EDIT) {
            callEditModeSubmit(form, that);
        }
        // // --------------------
        //
        // if (this.actionMode === ActionMode.ADD) {
        //   callAddModeSubmit(form, that);
        // } else if (this.actionMode === ActionMode.EDIT) {
        //   callEditModeSubmit(form, that);
        // }
    };
    __decorate([
        Input()
    ], BaseActionComponentSeven.prototype, "item", void 0);
    __decorate([
        Input()
    ], BaseActionComponentSeven.prototype, "actionMode", void 0);
    __decorate([
        Output()
    ], BaseActionComponentSeven.prototype, "addedItem", void 0);
    __decorate([
        Output()
    ], BaseActionComponentSeven.prototype, "editedItem", void 0);
    return BaseActionComponentSeven;
}(BaseAnyComponentSeven));

var BaseComponentSeven = /** @class */ (function (_super) {
    __extends(BaseComponentSeven, _super);
    function BaseComponentSeven(activatedRoute) {
        var _this = _super.call(this) || this;
        _this.activatedRoute = activatedRoute;
        _this.Toolkit2 = Toolkit2;
        _this.ActionMode = ActionMode;
        return _this;
    }
    BaseComponentSeven.prototype.receiveData = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            // console.log(data);
            _this.onReceiveRouteParam(data.modelContainer.routeParams);
            _this.onReceiveQueryParam(data.modelContainer.queryParams);
        });
    };
    BaseComponentSeven.prototype.getQueryParams = function () {
        return this.activatedRoute.snapshot.queryParams;
    };
    BaseComponentSeven.prototype.getUnFlatQueryParams = function (clazz, options) {
        return this.getUnFlatQueryParams2(clazz, null, options);
    };
    BaseComponentSeven.prototype.getUnFlatQueryParams2 = function (clazz, sample, options) {
        var convertCamelToLowerHyphen = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.queryParams, clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen });
    };
    BaseComponentSeven.prototype.getRouteParams = function () {
        return this.activatedRoute.snapshot.paramMap['params'];
    };
    BaseComponentSeven.prototype.getUnFlatRouteParams = function (clazz, options) {
        return this.getUnFlatRouteParams2(clazz, null, options);
    };
    BaseComponentSeven.prototype.getUnFlatRouteParams2 = function (clazz, sample, options) {
        var convertCamelToLowerHyphen1 = this.getConvertCamelToLowerHyphen(options);
        return this.Toolkit2.ObjectUtil.unFlatify2(this.activatedRoute.snapshot.paramMap['params'], clazz, sample, { convertCamelToLowerHyphen: convertCamelToLowerHyphen1 });
    };
    BaseComponentSeven.prototype.getConvertCamelToLowerHyphen = function (options) {
        var convertCamelToLowerHyphen = true;
        if (!isNullOrUndefined(options) &&
            !isNullOrUndefined(options.convertCamelToLowerHyphen)) {
            convertCamelToLowerHyphen = options.convertCamelToLowerHyphen;
        }
        else {
            convertCamelToLowerHyphen = true;
        }
        return convertCamelToLowerHyphen;
    };
    return BaseComponentSeven;
}(ComponentCanDeactivate));

var BaseCreateComponentSeven = /** @class */ (function (_super) {
    __extends(BaseCreateComponentSeven, _super);
    function BaseCreateComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.dialogService = dialogService;
        _this.createdItem = new EventEmitter(null);
        return _this;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    // canDeactivate(): Observable<boolean> | boolean {
    //   // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
    //   if (!this.getMainObject() ||
    //     JSON.stringify(this.getMainObject()) ===
    //     JSON.stringify(this.getMainObjectInDom())) {
    //     return true;
    //   }
    //   // Otherwise ask the group with the dialog service and return its
    //   // observable which resolves to true or false when the group decides
    //   return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    // }
    BaseCreateComponentSeven.prototype.afterCreate = function (res, form) {
        console.log(res);
        this.createdItem.emit(res);
        if (!isNullOrUndefined(form)) {
            form.resetForm();
        }
        // this.Toolkit2.SwalUtil.successAdd();
    };
    __decorate([
        Output()
    ], BaseCreateComponentSeven.prototype, "createdItem", void 0);
    return BaseCreateComponentSeven;
}(BaseAnyComponentSeven));

var BaseEditComponentSeven = /** @class */ (function (_super) {
    __extends(BaseEditComponentSeven, _super);
    function BaseEditComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.dialogService = dialogService;
        _this.editedItem = new EventEmitter(null);
        return _this;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    BaseEditComponentSeven.prototype.receiveItem = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            _this.onReceivedItem(data.item);
        });
    };
    // canDeactivate(): Observable<boolean> | boolean {
    //   // Allow synchronous navigation (`true`) if no crisis or the crisis is unchanged
    //   if (!this.getMainObject() ||
    //     JSON.stringify(this.getMainObject()) ===
    //     JSON.stringify(this.getMainObjectInDom())) {
    //     return true;
    //   }
    //   // Otherwise ask the group with the dialog service and return its
    //   // observable which resolves to true or false when the group decides
    //   return this.dialogService.confirm('صرف نظر کردن از تغییرات؟');
    // }
    BaseEditComponentSeven.prototype.afterEdit = function (res, form) {
        this.editedItem.emit(res);
        // // form.resetForm();
        // this.Toolkit2.SwalUtil.successEdit();
    };
    BaseEditComponentSeven.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        this.onChanges(changes);
    };
    __decorate([
        Input()
    ], BaseEditComponentSeven.prototype, "item", void 0);
    __decorate([
        Output()
    ], BaseEditComponentSeven.prototype, "editedItem", void 0);
    return BaseEditComponentSeven;
}(BaseAnyComponentSeven));

var ListMode;
(function (ListMode) {
    ListMode["DEFAULT"] = "DEFAULT";
    ListMode["CHOOSE_ONE"] = "CHOOSE_ONE";
    ListMode["CHOOSE_MULTI"] = "CHOOSE_MULTI";
    ListMode["VIEW"] = "VIEW";
})(ListMode || (ListMode = {}));

var BaseListComponentSeven = /** @class */ (function (_super) {
    __extends(BaseListComponentSeven, _super);
    function BaseListComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.MyListMode = ListMode;
        _this.selectedList = [];
        _this.selectedItem = new EventEmitter();
        _this.deSelectedItem = new EventEmitter();
        _this.firstOnThisRoute = true;
        return _this;
    }
    Object.defineProperty(BaseListComponentSeven.prototype, "listMode", {
        get: function () {
            return this._listMode;
        },
        set: function (val) {
            switch (val) {
                case ListMode.DEFAULT:
                    this.onDefaultMode();
                    break;
                case ListMode.CHOOSE_ONE:
                    this.onChooseOneMode();
                    break;
                case ListMode.CHOOSE_MULTI:
                    this.onChooseMultiMode();
                    break;
            }
            this._listMode = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseListComponentSeven.prototype, "triggerData", {
        get: function () {
            return this._triggerData;
        },
        set: function (value) {
            if (this._triggerData !== value) {
                this.getList();
                this._triggerData = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseListComponentSeven.prototype, "itemPage", {
        get: function () {
            return this._itemPage;
        },
        set: function (val) {
            var _this = this;
            console.log('itemPage---------------->', val);
            this.getComponentData().itemPage = val;
            if (this.listMode === ListMode.CHOOSE_MULTI) {
                this.getComponentData().itemPage.content.forEach(function (item, i) {
                    if (!isNullOrUndefined(_this.selectedList)) {
                        if (_this.selectedList.includes(item)) {
                            item['selected'] = true;
                        }
                    }
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    BaseListComponentSeven.prototype.getListRemote = function (optionsOfGetList) {
        this.getListOnCallback()(this.getListRemoteArg(optionsOfGetList));
    };
    BaseListComponentSeven.prototype.getList = function (optionsOfGetList) {
        this.getComponentData().itemPage = new PageContainer();
        console.log(this.getComponentData().itemPage);
        if (isNullOrUndefined(this.getListOnCallback())) {
            this.getListSelf(optionsOfGetList);
        }
        else {
            this.getListRemote(optionsOfGetList);
        }
    };
    BaseListComponentSeven.prototype.ngOnChanges = function (changes) {
    };
    BaseListComponentSeven.prototype.onChangeSize = function (event) {
        this.getComponentData().queryParam.paging.size = event.target.value;
        this.getComponentData().queryParam.paging.page = 0;
        this._setToQueryParams(this.getComponentData().queryParam);
    };
    BaseListComponentSeven.prototype.initiatePagination = function (value) {
        this.getComponentData().queryParam.paging.page =
            this.getComponentData().queryParamReal.paging.page ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            this.getComponentData().queryParamReal.paging.size ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    };
    BaseListComponentSeven.prototype.resetPagination = function (value) {
        this.getComponentData().queryParam.paging.page =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    };
    BaseListComponentSeven.prototype.setCurrentPage = function (page) {
        if (this.getComponentData().queryParamReal.paging.page !== page) {
            this.getComponentData().queryParam.paging.page = page;
            this._setToQueryParams(this.getComponentData().queryParam);
        }
    };
    BaseListComponentSeven.prototype.hardChangeQueryParamReal = function (queryParam) {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(queryParam));
    };
    BaseListComponentSeven.prototype.hardSyncQueryParamReal = function () {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(this.getComponentData().queryParam));
    };
    BaseListComponentSeven.prototype.defaultOnReceiveQueryParam = function (queryParam, optionsOfGetList) {
        if (this.getComponentData().queryParamReal.paging.page !== queryParam.paging.page ||
            this.getComponentData().queryParamReal.paging.size !== queryParam.paging.size) {
            if (this.firstOnThisRoute === false) {
                if (!isNullOrUndefined(queryParam.paging.page)) {
                    this.getComponentData().queryParamReal.paging = JSON.parse(JSON.stringify(queryParam.paging));
                }
                /**
                 * Should remove next line
                 */
                this.getList(optionsOfGetList);
            }
            else {
                this.firstOnThisRoute = false;
            }
        }
        if (this.getComponentData().queryParamReal.itemId !== queryParam.itemId) {
            this.getComponentData().queryParamReal.itemId = queryParam.itemId;
        }
    };
    BaseListComponentSeven.prototype.defaultOnReceiveRouteParam = function () {
        this.firstOnThisRoute = true;
    };
    BaseListComponentSeven.prototype.defaultSortify = function (sortings, event) {
        console.log(event.target.attributes.field);
        console.log(event.target.attributes.sortdirection);
        switch (event.target.attributes.sortdirection) {
            case 'null':
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
            case 'asc':
                event.target.attributes.sortdirection = 'desc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'desc'] });
                break;
            case 'desc':
                event.target.attributes.sortdirection = 'null';
                sortings = [];
                break;
            default:
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
        }
        return sortings;
    };
    BaseListComponentSeven.prototype.processPage = function (optionsOfGetList) {
        if (this.getComponentData().itemPage.content.length <= 0) {
            if (this.getComponentData().itemPage.last) {
                if (this.getComponentData().queryParamReal.paging.page > 0) {
                    this.getComponentData().queryParam.paging.page--;
                    this._setToQueryParams(this.getComponentData().queryParam);
                }
            }
            else {
                this.getList(optionsOfGetList);
            }
        }
    };
    __decorate([
        Input()
    ], BaseListComponentSeven.prototype, "selectedList", void 0);
    __decorate([
        Input()
    ], BaseListComponentSeven.prototype, "listMode", null);
    __decorate([
        Input()
    ], BaseListComponentSeven.prototype, "triggerData", null);
    __decorate([
        Input()
    ], BaseListComponentSeven.prototype, "itemPage", null);
    __decorate([
        Output()
    ], BaseListComponentSeven.prototype, "selectedItem", void 0);
    __decorate([
        Output()
    ], BaseListComponentSeven.prototype, "deSelectedItem", void 0);
    return BaseListComponentSeven;
}(BaseAnyComponentSeven));

var BaseListComponentSeven2 = /** @class */ (function (_super) {
    __extends(BaseListComponentSeven2, _super);
    function BaseListComponentSeven2(activatedRoute, router, routeParamClazzType, queryParamClazzType) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.MyListMode = ListMode;
        _this.selectedList = [];
        _this.serviceIsRemote = false;
        _this.callRemoteService = new EventEmitter();
        _this.selectedItem = new EventEmitter();
        _this.deSelectedItem = new EventEmitter();
        _this.firstOnThisRoute = true;
        return _this;
    }
    Object.defineProperty(BaseListComponentSeven2.prototype, "listMode", {
        get: function () {
            return this._listMode;
        },
        set: function (val) {
            switch (val) {
                case ListMode.DEFAULT:
                    this.onDefaultMode();
                    break;
                case ListMode.CHOOSE_ONE:
                    this.onChooseOneMode();
                    break;
                case ListMode.CHOOSE_MULTI:
                    this.onChooseMultiMode();
                    break;
            }
            this._listMode = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseListComponentSeven2.prototype, "triggerData", {
        get: function () {
            return this._triggerData;
        },
        set: function (value) {
            if (this._triggerData !== value) {
                this.getList();
                this._triggerData = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseListComponentSeven2.prototype, "itemPage", {
        get: function () {
            return this._itemPage;
        },
        set: function (val) {
            var _this = this;
            console.log('itemPage---------------->', val);
            this.getComponentData().itemPage = val;
            if (this.listMode === ListMode.CHOOSE_MULTI) {
                this.getComponentData().itemPage.content.forEach(function (item, i) {
                    if (!isNullOrUndefined(_this.selectedList)) {
                        if (_this.selectedList.includes(item)) {
                            item['selected'] = true;
                        }
                    }
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    BaseListComponentSeven2.prototype.getListRemote = function (optionsOfGetList) {
        this.callRemoteService.emit(this.getListRemoteArg(optionsOfGetList));
    };
    BaseListComponentSeven2.prototype.getList = function (optionsOfGetList) {
        this.getComponentData().itemPage = new PageContainer();
        console.log(this.getComponentData().itemPage);
        if (!this.serviceIsRemote) {
            this.getListSelf(optionsOfGetList);
        }
        else {
            this.getListRemote(optionsOfGetList);
        }
    };
    BaseListComponentSeven2.prototype.ngOnChanges = function (changes) {
    };
    BaseListComponentSeven2.prototype.onChangeSize = function (event) {
        this.getComponentData().queryParam.paging.size = event.target.value;
        this.getComponentData().queryParam.paging.page = 0;
        this._setToQueryParams(this.getComponentData().queryParam);
    };
    BaseListComponentSeven2.prototype.initiatePagination = function (value) {
        this.getComponentData().queryParam.paging.page =
            this.getComponentData().queryParamReal.paging.page ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            this.getComponentData().queryParamReal.paging.size ||
                !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    };
    BaseListComponentSeven2.prototype.resetPagination = function (value) {
        this.getComponentData().queryParam.paging.page =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.page : 0;
        this.getComponentData().queryParam.paging.size =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.size) ? value.size : 5;
        this.getComponentData().indicatorCount =
            !isNullOrUndefined(value) && !isNullOrUndefined(value.page) ? value.indicatorCount : 5;
    };
    BaseListComponentSeven2.prototype.setCurrentPage = function (page) {
        if (this.getComponentData().queryParamReal.paging.page !== page) {
            this.getComponentData().queryParam.paging.page = page;
            this._setToQueryParams(this.getComponentData().queryParam);
        }
    };
    BaseListComponentSeven2.prototype.setCurrentSize = function (size) {
        if (this.getComponentData().queryParamReal.paging.size !== size) {
            this.getComponentData().queryParam.paging.size = size;
            this._setToQueryParams(this.getComponentData().queryParam);
        }
    };
    BaseListComponentSeven2.prototype.getCurrentPage = function () {
        return this.getComponentData().queryParamReal.paging.page;
    };
    BaseListComponentSeven2.prototype.hardChangeQueryParamReal = function (queryParam) {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(queryParam));
    };
    BaseListComponentSeven2.prototype.hardSyncQueryParamReal = function () {
        this.getComponentData().queryParamReal = JSON.parse(JSON.stringify(this.getComponentData().queryParam));
    };
    BaseListComponentSeven2.prototype.defaultOnReceiveQueryParam = function (queryParam, optionsOfGetList) {
        if (this.getComponentData().queryParamReal.paging.page !== queryParam.paging.page ||
            this.getComponentData().queryParamReal.paging.size !== queryParam.paging.size) {
            if (this.firstOnThisRoute === false) {
                if (!isNullOrUndefined(queryParam.paging.page)) {
                    this.getComponentData().queryParamReal.paging = JSON.parse(JSON.stringify(queryParam.paging));
                }
                /**
                 * Should remove next line
                 */
                this.getList(optionsOfGetList);
            }
            else {
                this.firstOnThisRoute = false;
            }
        }
        if (this.getComponentData().queryParamReal.itemId !== queryParam.itemId) {
            this.getComponentData().queryParamReal.itemId = queryParam.itemId;
        }
    };
    BaseListComponentSeven2.prototype.defaultOnReceiveRouteParam = function () {
        this.firstOnThisRoute = true;
    };
    BaseListComponentSeven2.prototype.defaultSortify = function (sortings, event) {
        console.log(event.target.attributes.field);
        console.log(event.target.attributes.sortdirection);
        switch (event.target.attributes.sortdirection) {
            case 'null':
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
            case 'asc':
                event.target.attributes.sortdirection = 'desc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'desc'] });
                break;
            case 'desc':
                event.target.attributes.sortdirection = 'null';
                sortings = [];
                break;
            default:
                event.target.attributes.sortdirection = 'asc';
                sortings = [];
                sortings.push({ sort: [event.target.attributes.field.value, 'asc'] });
                break;
        }
        return sortings;
    };
    BaseListComponentSeven2.prototype.processPage = function (optionsOfGetList) {
        if (this.getComponentData().itemPage.content.length <= 0) {
            if (this.getComponentData().itemPage.last) {
                if (this.getComponentData().queryParamReal.paging.page > 0) {
                    this.getComponentData().queryParam.paging.page--;
                    this._setToQueryParams(this.getComponentData().queryParam);
                }
            }
            else {
                this.getList(optionsOfGetList);
            }
        }
    };
    __decorate([
        Input()
    ], BaseListComponentSeven2.prototype, "selectedList", void 0);
    __decorate([
        Input()
    ], BaseListComponentSeven2.prototype, "serviceIsRemote", void 0);
    __decorate([
        Output()
    ], BaseListComponentSeven2.prototype, "callRemoteService", void 0);
    __decorate([
        Input()
    ], BaseListComponentSeven2.prototype, "listMode", null);
    __decorate([
        Input()
    ], BaseListComponentSeven2.prototype, "triggerData", null);
    __decorate([
        Input()
    ], BaseListComponentSeven2.prototype, "itemPage", null);
    __decorate([
        Output()
    ], BaseListComponentSeven2.prototype, "selectedItem", void 0);
    __decorate([
        Output()
    ], BaseListComponentSeven2.prototype, "deSelectedItem", void 0);
    return BaseListComponentSeven2;
}(BaseAnyComponentSeven));

var BaseReceiverComponentSeven = /** @class */ (function (_super) {
    __extends(BaseReceiverComponentSeven, _super);
    function BaseReceiverComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.dialogService = dialogService;
        return _this;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    BaseReceiverComponentSeven.prototype.receiveItem = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            _this.onReceivedItem(data.item);
        });
    };
    BaseReceiverComponentSeven.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        this.onChanges(changes);
    };
    __decorate([
        Input()
    ], BaseReceiverComponentSeven.prototype, "item", void 0);
    return BaseReceiverComponentSeven;
}(BaseAnyComponentSeven));

var BaseViewComponentSeven = /** @class */ (function (_super) {
    __extends(BaseViewComponentSeven, _super);
    function BaseViewComponentSeven(activatedRoute, router, routeParamClazzType, queryParamClazzType, dialogService) {
        var _this = _super.call(this, activatedRoute, router, routeParamClazzType, queryParamClazzType) || this;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.routeParamClazzType = routeParamClazzType;
        _this.queryParamClazzType = queryParamClazzType;
        _this.dialogService = dialogService;
        return _this;
        // for (const property of this.Toolkit2.ObjectUtil
        //   .getObjectPropertyList(this.featurePrefix)) {
        //   if (this.featurePrefix.hasOwnProperty(property) &&
        //     activatedRoute.snapshot.params.hasOwnProperty(property)) {
        //     this.featurePrefix[property] = activatedRoute.snapshot.params[property];
        //   }
        // }
    }
    BaseViewComponentSeven.prototype.receiveItem = function () {
        var _this = this;
        this.activatedRoute.data
            .subscribe(function (data) {
            _this.onReceivedItem(data.item);
        });
    };
    BaseViewComponentSeven.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('item') && !isNullOrUndefined(this.item)) {
            this.onReceivedItem(this.item);
        }
        this.onChanges(changes);
    };
    __decorate([
        Input()
    ], BaseViewComponentSeven.prototype, "item", void 0);
    return BaseViewComponentSeven;
}(BaseAnyComponentSeven));

var ListComponentData = /** @class */ (function () {
    function ListComponentData(routeParamClazzType, queryParamClazzType) {
        this.routeParamClazzType = routeParamClazzType;
        this.queryParamClazzType = queryParamClazzType;
        this.sizeList = [5, 10, 15, 20, 25];
        this.queryParam = new queryParamClazzType();
        this.routeParam = new routeParamClazzType();
        this.queryParamReal = new queryParamClazzType();
        this.routeParamReal = new routeParamClazzType();
        this.itemPage = new PageContainer();
        this.itemPage.content = [];
        this.sortings = [];
    }
    ListComponentData.prototype.init = function (init) {
        if (!isNullOrUndefined(init)) {
            this.sortings = init.sortings || [];
            this.term = init.term || '';
            this.sizeList = init.sizeList || [5, 10, 15, 20, 25];
        }
    };
    return ListComponentData;
}());

var ListQueryParam = /** @class */ (function () {
    function ListQueryParam() {
        this.paging = new Paging();
        this.itemId = null;
        this.term = null;
    }
    return ListQueryParam;
}());

var ModelContainer = /** @class */ (function () {
    function ModelContainer(routeParams, queryParams, item, actionMode) {
        this.item = item;
        this.routeParams = routeParams;
        this.queryParams = queryParams;
        this.actionMode = actionMode;
    }
    return ModelContainer;
}());

var BaseActionResolver = /** @class */ (function () {
    function BaseActionResolver(router, _GlobalConfigurations) {
        this.router = router;
        this._GlobalConfigurations = _GlobalConfigurations;
    }
    BaseActionResolver.prototype.resolve = function (route, state) {
        this.actionMode = route.paramMap.get('actionMode');
        // if (itemId !== this._GlobalConfigurations.getRoutingNoArgument()) {
        //   return this.callResolveService(route.paramMap['params'], itemId);
        return this.callResolveService(route.paramMap['params'], route.queryParams);
        // } else {
        //   return this.retResolved(null);
        // }
    };
    BaseActionResolver.prototype.retResolved = function (routeParams, queryParams, res) {
        var modelContainer = new ModelContainer(routeParams);
        modelContainer.actionMode = ActionMode[this.actionMode];
        modelContainer.routeParams = routeParams;
        modelContainer.queryParams = queryParams;
        if (res) {
            modelContainer.item = res;
            // alert('waaaw, modelContainer: ' + JSON.stringify(modelContainer));
        }
        else { // id not found
            modelContainer.item = null;
        }
        return modelContainer;
    };
    return BaseActionResolver;
}());

var BaseAnyResolver = /** @class */ (function () {
    function BaseAnyResolver(router) {
        this.router = router;
    }
    BaseAnyResolver.prototype.resolve = function (route, state) {
        return this.callResolveService(route);
    };
    BaseAnyResolver.prototype.retResolved = function (res) {
        return res;
    };
    return BaseAnyResolver;
}());

var BaseReceiveResolver = /** @class */ (function () {
    function BaseReceiveResolver(router, _GlobalConfigurations) {
        this.router = router;
        this._GlobalConfigurations = _GlobalConfigurations;
    }
    BaseReceiveResolver.prototype.resolve = function (route, state) {
        // if (itemId !== this._GlobalConfigurations.getRoutingNoArgument()) {
        //   return this.callResolveService(route.paramMap['params'], itemId);
        return this.callResolveService(route.paramMap['params'], route.queryParams);
        // } else {
        //   return this.retResolved(null);
        // }
    };
    BaseReceiveResolver.prototype.retResolved = function (routeParams, queryParams, res) {
        var modelContainer = new ModelContainer(routeParams);
        modelContainer.routeParams = routeParams;
        modelContainer.queryParams = queryParams;
        if (res) {
            modelContainer.item = res;
            // alert('waaaw, modelContainer: ' + JSON.stringify(modelContainer));
        }
        else { // id not found
            modelContainer.item = null;
        }
        return modelContainer;
    };
    return BaseReceiveResolver;
}());

/*
 * Public API Surface of common
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ActionItem, BaseActionComponentFive, BaseActionComponentOne, BaseActionComponentSeven, BaseActionComponentThree, BaseActionComponentTwo, BaseActionResolver, BaseAddComponentFive, BaseAddComponentOne, BaseAddComponentTwo, BaseAnyComponentSeven, BaseAnyResolver, BaseComponentFive, BaseComponentOne, BaseComponentSeven, BaseComponentThree, BaseComponentTwo, BaseCreateComponentSeven, BaseEditComponentFive, BaseEditComponentSeven, BaseEditComponentTwo, BaseListComponentFive, BaseListComponentOne, BaseListComponentSeven, BaseListComponentSeven2, BaseListComponentThree, BaseListComponentTwo, BaseReceiveResolver, BaseReceiverComponentSeven, BaseViewComponentFive, BaseViewComponentSeven, BaseViewComponentTwo, CanDeactivateGuard, CommonComponent, CommonService, ComponentCanDeactivate, FormCanDeactivate, ListComponentData, ListMode, ListQueryParam, NbCommonModule, SectionObject, ShrPaginationEvent, IfAddModeDirective as ɵa, IfAddOrViewModeDirective as ɵb, IfEditModeDirective as ɵc, IfEditOrAddModeDirective as ɵd, IfEditOrViewModeDirective as ɵe, IfViewModeDirective as ɵf, FloatLabelDirective as ɵg, ShrPaginationModule as ɵh, PaginationComponent as ɵi, ShrSortingIconModule as ɵj, SortingIconComponent as ɵk, ComponentCanDeactivate as ɵl };
//# sourceMappingURL=angular-boot-common.js.map
