/**
 * @author Jafar Amini in March 2018.
 */
import { OnChanges, SimpleChange } from '@angular/core';
import { NgForm } from '@angular/forms';
import { BaseComponentFive } from './base-component-five';
import { ActivatedRoute } from '@angular/router';
import { ActionMode } from '@angular-boot/util';
import { Observable } from 'rxjs';
import { DialogService } from '@angular-boot/util';
import { GlobalConfigurations } from '@angular-boot/core';
export declare abstract class BaseActionComponentFive<T, Prefix> extends BaseComponentFive implements OnChanges {
    protected featurePrefix: Prefix;
    protected activatedRoute: ActivatedRoute;
    protected dialogService: DialogService;
    protected globalConfigurations: GlobalConfigurations;
    actionMode: ActionMode;
    receiveData(): void;
    abstract onAddMode(): any;
    abstract onEditMode(item: any): any;
    abstract onViewMode(item: any): any;
    abstract onReceivedItem(item: any): any;
    abstract onChanges(obj: any): any;
    abstract getMainObject(): Object;
    abstract getMainObjectInDom(): Object;
    constructor(featurePrefix: Prefix, activatedRoute: ActivatedRoute, dialogService: DialogService, globalConfigurations: GlobalConfigurations);
    canDeactivate(): Observable<boolean> | boolean;
    applyMode(changeMode: ActionMode, item: any): void;
    afterAdd(form: any, res: any, msg?: {
        title?: string;
        text?: string;
    }): void;
    afterEdit(form: any, res: any, msg?: {
        title?: string;
        text?: string;
    }): void;
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    onSubmit(form: NgForm, formIsValidSubmitted: any, callAddModeSubmit?: any, callEditModeSubmit?: any, that?: any): void;
}
