/**
 * @author Jafar Amini in March 2018.
 */
import { EventEmitter, OnChanges, SimpleChange } from '@angular/core';
import { NgForm } from '@angular/forms';
import { ActivatedRoute } from '@angular/router';
import { BaseComponentOne } from './base-component-one';
import { ActionMode } from '@angular-boot/util';
import { GlobalConfigurations } from '@angular-boot/core';
export declare abstract class BaseActionComponentOne<T> extends BaseComponentOne implements OnChanges {
    protected activatedRoute: ActivatedRoute;
    protected globalConfigurations: GlobalConfigurations;
    itemId_In: string;
    actionMode_In: ActionMode;
    item_Added_Out: EventEmitter<T>;
    item_Edited_Out: EventEmitter<T>;
    abstract onAddMode(): any;
    abstract onEditMode(): any;
    abstract onViewMode(): any;
    abstract onReceivedItemId(itemId: any): any;
    abstract onChanges(obj: any): any;
    constructor(activatedRoute: ActivatedRoute, globalConfigurations: GlobalConfigurations);
    lookQueryParams(): void;
    applyMode(changeMode: ActionMode): void;
    afterAdd(form: any, res: any, msg?: {
        title?: string;
        text?: string;
    }): void;
    afterEdit(form: any, res: any, msg?: {
        title?: string;
        text?: string;
    }): void;
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    onSubmit(form: NgForm, formIsValidSubmitted: any, callAddModeSubmit?: any, callEditModeSubmit?: any, that?: any): void;
}
