/**
 * @author Jafar Amini in March 2018.
 */
import { EventEmitter, OnChanges, SimpleChange } from '@angular/core';
import { NgForm } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { ActionMode } from '@angular-boot/util';
import { DialogService } from '@angular-boot/util';
import { BaseAnyComponentSeven } from './base-any-component-seven';
export declare abstract class BaseActionComponentSeven<RouteParamClazz, QueryParamClazz, T> extends BaseAnyComponentSeven<RouteParamClazz, QueryParamClazz> implements OnChanges {
    activatedRoute: ActivatedRoute;
    router: Router;
    routeParamClazzType: (new () => RouteParamClazz);
    queryParamClazzType: (new () => QueryParamClazz);
    dialogService: DialogService;
    item: T;
    actionMode: ActionMode;
    addedItem: EventEmitter<T>;
    editedItem: EventEmitter<T>;
    receiveActionMode(afterModeChange?: any): void;
    receiveItem(): void;
    abstract onAddMode(): any;
    abstract onEditMode(): any;
    abstract onViewMode(): any;
    abstract onReceivedItem(item: any): any;
    abstract onChanges(changes: {
        [propKey: string]: SimpleChange;
    }): any;
    abstract getMainObject(): any;
    abstract getMainObjectInDom(): any;
    constructor(activatedRoute: ActivatedRoute, router: Router, routeParamClazzType: (new () => RouteParamClazz), queryParamClazzType: (new () => QueryParamClazz), dialogService: DialogService);
    applyMode(changeMode: ActionMode): void;
    afterAdd(res: any, form?: any): void;
    afterEdit(res: any, form?: any): void;
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    onSubmit(form: NgForm, formIsValidSubmitted: any, callAddModeSubmit?: any, callEditModeSubmit?: any, that?: any): void;
}
