/**
 * @author Jafar Amini in March 2018.
 */
import { Toolkit2, UnFlatifyOptions } from '@angular-boot/util';
import { ActivatedRoute, Router } from '@angular/router';
import { ComponentCanDeactivate } from '../../routing';
export declare abstract class BaseAnyComponentSeven<RouteParamClazz, QueryParamClazz> extends ComponentCanDeactivate {
    activatedRoute: ActivatedRoute;
    router: Router;
    Toolkit2: typeof Toolkit2;
    queryParamClazz: QueryParamClazz;
    routeParamClazz: RouteParamClazz;
    currentQueryParam: any;
    previousQueryParam: any;
    routeParamClazzType: any;
    queryParamClazzType: any;
    constructor(activatedRoute: ActivatedRoute, router: Router, routeParamClazzType: (new () => RouteParamClazz), queryParamClazzType: (new () => QueryParamClazz));
    abstract canDeactivate(): boolean;
    receiveData(): void;
    setToQueryParams(obj: any, options?: {
        skipLocationChange?: boolean;
        replaceUrl?: boolean;
        removeIfEmpty?: boolean;
    }): void;
    abstract onReceiveRouteParam(routeParam: RouteParamClazz): any;
    abstract onReceiveQueryParam(queryParam: QueryParamClazz): any;
    abstract onReceiveRouteData(routeData: any): any;
    getQueryParams(): any;
    getUnFlatQueryParams(clazz: any, options?: UnFlatifyOptions): QueryParamClazz;
    getUnFlatQueryParams2(clazz: any, sample: any, options?: UnFlatifyOptions): any;
    getRouteParams(): any;
    getUnFlatRouteParams(clazz: any, options?: UnFlatifyOptions): RouteParamClazz;
    getUnFlatRouteParams2(clazz: any, sample: any, options?: UnFlatifyOptions): any;
    private getConvertCamelToLowerHyphen;
}
