import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { PageContainer } from '@angular-boot/util';
import { ActivatedRoute, Router } from '@angular/router';
import { ListComponentData } from './list-component-data';
import { ListQueryParam } from './list-query-param';
import { ListMode } from './list-mode.enum';
import { BaseAnyComponentSeven } from './base-any-component-seven';
export declare abstract class BaseListComponentSeven2<RouteParamClazz, QueryParamClazz extends ListQueryParam, ComponentDataClazz extends ListComponentData<T, RouteParamClazz, QueryParamClazz>, T> extends BaseAnyComponentSeven<RouteParamClazz, QueryParamClazz> implements OnChanges {
    activatedRoute: ActivatedRoute;
    router: Router;
    routeParamClazzType: (new () => RouteParamClazz);
    queryParamClazzType: (new () => QueryParamClazz);
    protected firstOnThisRoute: boolean;
    constructor(activatedRoute: ActivatedRoute, router: Router, routeParamClazzType: (new () => RouteParamClazz), queryParamClazzType: (new () => QueryParamClazz));
    MyListMode: typeof ListMode;
    selectedList: T[];
    serviceIsRemote: boolean;
    callRemoteService: EventEmitter<any>;
    abstract getComponentData(): ComponentDataClazz;
    _listMode: ListMode;
    listMode: ListMode;
    protected _triggerData: boolean;
    triggerData: boolean;
    protected _itemPage: PageContainer<T>;
    itemPage: PageContainer<T>;
    selectedItem: EventEmitter<T>;
    deSelectedItem: EventEmitter<T>;
    abstract onDefaultMode(): any;
    abstract onChooseOneMode(): any;
    abstract onChooseMultiMode(): any;
    abstract getListSelf(optionsOfGetList?: any): any;
    abstract getListRemoteArg(optionsOfGetList?: any): any;
    abstract chooseSelectedItemForEdit(item: T): any;
    abstract chooseSelectedItemForView(item: T): any;
    abstract deleteItem(item: T): any;
    abstract onChangedTerm(): any;
    getListRemote(optionsOfGetList?: any): void;
    getList(optionsOfGetList?: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    protected abstract _setToQueryParams(queryParam: any): any;
    onChangeSize(event: any): void;
    initiatePagination(value?: {
        page?: number;
        size?: number;
        indicatorCount?: number;
    }): void;
    resetPagination(value?: {
        page?: number;
        size?: number;
        indicatorCount?: number;
    }): void;
    setCurrentPage(page: any): void;
    setCurrentSize(size: any): void;
    getCurrentPage(): number;
    hardChangeQueryParamReal(queryParam: QueryParamClazz): void;
    hardSyncQueryParamReal(): void;
    defaultOnReceiveQueryParam(queryParam: any, optionsOfGetList?: any): any;
    defaultOnReceiveRouteParam(): void;
    abstract sortify(event: any): any;
    defaultSortify(sortings: any, event: any): any;
    protected processPage(optionsOfGetList?: any): void;
}
